/*===========================================================================*/
/*   (Llib/util.scm)                                                         */
/*   Bigloo (4.4c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Tue Jan 4 08:39:25 AM CET 2022      */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo-4.4c-4/bin/bigloo -O3 -fcfa-arithmetic -rm -q -lib-dir /builddir/build/BUILD/bigloo-4.4c-4/lib/bigloo/4.4c -I Llib -lib-dir /builddir/build/BUILD/bigloo-4.4c-4/lib/bigloo/4.4c -unsafe -safee -copt -fPIC -copt -IPosix Llib/util.scm -o objs/util.o -c) */
/* GC selection */
#define THE_GC BOEHM_GC

/* unsafe mode */
#define BIGLOO_UNSAFE 1

/* traces mode */
#define BIGLOO_TRACE 0

/* standard Bigloo include */
#include <bigloo.h>

#ifdef __cplusplus
extern "C" {
#endif
BGL_IMPORT obj_t BGl_gcdbxz00zz__r4_numbers_6_5_fixnumz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_modzd2inversezd2zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_EXPORTED_DECL unsigned char BGl_charzd2xorzd2zz__cryptozd2utilzd2(unsigned char, unsigned char);
static obj_t BGl_requirezd2initializa7ationz75zz__cryptozd2utilzd2 = BUNSPEC;
static obj_t BGl_makezd2bglrandomzd2stringze70ze7zz__cryptozd2utilzd2(long);
BGL_IMPORT obj_t bgl_bignum_quotient(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_stringzd2xorzd2zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_sha512sumz00zz__sha2z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_makezd2randomzd2primez00zz__cryptozd2utilzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_makezd2randomzd2bignumz00zz__cryptozd2utilzd2(long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_md5sumzd2binzd2zz__cryptozd2utilzd2(obj_t);
static obj_t BGl_z62charzd2ze3bignumz53zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_warningz00zz__errorz00(obj_t);
BGL_IMPORT obj_t BGl_md5sumz00zz__md5z00(obj_t);
static obj_t BGl_z62stringzd2xorzb0zz__cryptozd2utilzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bignumzd2ze3binzd2strz12zf1zz__cryptozd2utilzd2(obj_t, long, obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_stringzd2xorz12zc0zz__cryptozd2utilzd2(obj_t, obj_t, obj_t);
static obj_t BGl_z62md5sumzd2binzb0zz__cryptozd2utilzd2(obj_t, obj_t);
static obj_t BGl_genericzd2initzd2zz__cryptozd2utilzd2();
BGL_IMPORT obj_t BGl_stringzd2hexzd2internz12z12zz__r4_strings_6_7z00(obj_t);
BGL_IMPORT long bgl_bignum_to_long(obj_t);
BGL_IMPORT obj_t bgl_bignum_remainder(obj_t, obj_t);
static obj_t BGl_objectzd2initzd2zz__cryptozd2utilzd2();
BGL_IMPORT obj_t bgl_bignum_mul(obj_t, obj_t);
BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sha1sumzd2binzd2zz__cryptozd2utilzd2(obj_t);
static obj_t BGl_z62modzd2inversezb0zz__cryptozd2utilzd2(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t bgl_bignum_add(obj_t, obj_t);
BGL_IMPORT bool_t bgl_bignum_even(obj_t);
static obj_t BGl_z62bignumzd2ze3charz53zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
BGL_IMPORT obj_t bgl_rand_bignum(obj_t);
BGL_EXPORTED_DECL obj_t BGl_hexzd2strzd2ze3stringz12zf1zz__cryptozd2utilzd2(obj_t);
static obj_t BGl__makezd2randomzd2stringz00zz__cryptozd2utilzd2(obj_t, obj_t);
static obj_t BGl_z62readzd2armoredzd2base64zd2datazb0zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__cryptozd2utilzd2();
static obj_t BGl__bignumzd2ze3binzd2strze3zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_modulobxz00zz__r4_numbers_6_5_fixnumz00(obj_t, obj_t);
static obj_t BGl_z62zc3z04anonymousza31163ze3ze5zz__cryptozd2utilzd2(obj_t);
BGL_IMPORT obj_t BGl_sha1sumz00zz__sha1z00(obj_t);
static obj_t BGl_z62stringzd2xorz12za2zz__cryptozd2utilzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t make_string(long, unsigned char);
BGL_IMPORT obj_t bgl_close_input_port(obj_t);
BGL_IMPORT obj_t bgl_bignum_sub(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_binzd2strzd2ze3bignumze3zz__cryptozd2utilzd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_strzd2ze3hexzd2stringze3zz__cryptozd2utilzd2(obj_t);
static obj_t BGl_z62binzd2strzd2ze3bignumz81zz__cryptozd2utilzd2(obj_t, obj_t);
static obj_t BGl_z62strzd2ze3hexzd2stringz81zz__cryptozd2utilzd2(obj_t, obj_t);
static obj_t BGl_z62sha512sumzd2binzb0zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_EXPORTED_DECL long BGl_bignumzd2bitzd2lengthz00zz__cryptozd2utilzd2(obj_t);
BGL_IMPORT obj_t string_append(obj_t, obj_t);
BGL_IMPORT obj_t bgl_long_to_bignum(long);
BGL_IMPORT obj_t BGl_stringzd2hexzd2externz00zz__r4_strings_6_7z00(obj_t, int, long);
static obj_t BGl_z62sha256sumzd2binzb0zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_EXPORTED_DECL long BGl_zf2ceilingfxzf2zz__cryptozd2utilzd2(long, long);
BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_sha256sumz00zz__sha2z00(obj_t);
static obj_t BGl_z62stringzd2xorzd2bufferz12z70zz__cryptozd2utilzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62sha1sumzd2binzb0zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_IMPORT long BGl_modulofxz00zz__r4_numbers_6_5_fixnumz00(long, long);
static obj_t BGl_z62hexzd2strzd2ze3stringz12z93zz__cryptozd2utilzd2(obj_t, obj_t);
static obj_t BGl_z62zf2ceilingfxz90zz__cryptozd2utilzd2(obj_t, obj_t, obj_t);
static obj_t BGl_gcdzd2extzd2zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_bignumzd2ze3binzd2strze3zz__cryptozd2utilzd2(obj_t, long);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2utilzd2(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__sha2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__sha1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__md5z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__base64z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t fexists(char *);
BGL_IMPORT obj_t BGl_remainderz00zz__r4_numbers_6_5_fixnumz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_readzd2armoredzd2base64zd2datazd2zz__cryptozd2utilzd2(obj_t);
BGL_EXPORTED_DECL obj_t BGl_makezd2randomzd2stringz00zz__cryptozd2utilzd2(long, obj_t);
BGL_EXPORTED_DECL obj_t BGl_charzd2ze3bignumz31zz__cryptozd2utilzd2(unsigned char);
BGL_IMPORT obj_t BGl_readzd2linezd2zz__r4_input_6_10_2z00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__cryptozd2utilzd2();
static obj_t BGl_libraryzd2moduleszd2initz00zz__cryptozd2utilzd2();
static obj_t BGl_exptzd2modze70z35zz__cryptozd2utilzd2(obj_t, obj_t, obj_t);
static obj_t BGl_gczd2rootszd2initz00zz__cryptozd2utilzd2();
static obj_t BGl_z62charzd2xorzb0zz__cryptozd2utilzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_hexzd2strzd2ze3stringze3zz__cryptozd2utilzd2(obj_t);
static obj_t BGl_z62hexzd2strzd2ze3stringz81zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_base64zd2decodezd2zz__base64z00(obj_t, obj_t);
static obj_t BGl__makezd2randomzd2bignumz00zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_sha512sumzd2binzd2zz__cryptozd2utilzd2(obj_t);
BGL_IMPORT bool_t bgl_bignum_odd(obj_t);
static obj_t BGl__makezd2randomzd2primez00zz__cryptozd2utilzd2(obj_t, obj_t);
static obj_t BGl_z62bignumzd2bitzd2lengthz62zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_IMPORT obj_t BGl_stringzd2hexzd2internz00zz__r4_strings_6_7z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_sha256sumzd2binzd2zz__cryptozd2utilzd2(obj_t);
BGL_IMPORT obj_t BGl_readzd2charszd2zz__r4_input_6_10_2z00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_exptzd2modbxzd2zz__cryptozd2utilzd2(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL unsigned char BGl_bignumzd2ze3charz31zz__cryptozd2utilzd2(obj_t);
static obj_t BGl__bignumzd2ze3binzd2strz12zf1zz__cryptozd2utilzd2(obj_t, obj_t);
BGL_IMPORT bool_t BGl_stringzd2prefixzf3z21zz__r4_strings_6_7z00(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z62exptzd2modbxzb0zz__cryptozd2utilzd2(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT int bgl_bignum_cmp(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_stringzd2xorzd2bufferz12z12zz__cryptozd2utilzd2(obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
static obj_t __cnst[ 10 ] ;


DEFINE_EXPORT_BGL_PROCEDURE( BGl_charzd2ze3bignumzd2envze3zz__cryptozd2utilzd2, BgL_bgl_za762charza7d2za7e3big1752za7, BGl_z62charzd2ze3bignumz53zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_strzd2ze3hexzd2stringzd2envz31zz__cryptozd2utilzd2, BgL_bgl_za762strza7d2za7e3hexza71753z00, BGl_z62strzd2ze3hexzd2stringz81zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bignumzd2bitzd2lengthzd2envzd2zz__cryptozd2utilzd2, BgL_bgl_za762bignumza7d2bitza71754za7, BGl_z62bignumzd2bitzd2lengthz62zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bignumzd2ze3binzd2strzd2envz31zz__cryptozd2utilzd2, BgL_bgl__bignumza7d2za7e3bin1755z00, opt_generic_entry, BGl__bignumzd2ze3binzd2strze3zz__cryptozd2utilzd2, BFALSE, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_hexzd2strzd2ze3stringz12zd2envz23zz__cryptozd2utilzd2, BgL_bgl_za762hexza7d2strza7d2za71756z00, BGl_z62hexzd2strzd2ze3stringz12z93zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_modzd2inversezd2envz00zz__cryptozd2utilzd2, BgL_bgl_za762modza7d2inverse1757z00, BGl_z62modzd2inversezb0zz__cryptozd2utilzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_readzd2armoredzd2base64zd2datazd2envz00zz__cryptozd2utilzd2, BgL_bgl_za762readza7d2armore1758z00, BGl_z62readzd2armoredzd2base64zd2datazb0zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_md5sumzd2binzd2envz00zz__cryptozd2utilzd2, BgL_bgl_za762md5sumza7d2binza71759za7, BGl_z62md5sumzd2binzb0zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bignumzd2ze3charzd2envze3zz__cryptozd2utilzd2, BgL_bgl_za762bignumza7d2za7e3c1760za7, BGl_z62bignumzd2ze3charz53zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sha1sumzd2binzd2envz00zz__cryptozd2utilzd2, BgL_bgl_za762sha1sumza7d2bin1761z00, BGl_z62sha1sumzd2binzb0zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1713z00zz__cryptozd2utilzd2, BgL_bgl_string1713za700za7za7_1762za7, "/builddir/build/BUILD/bigloo-4.4c-4/api/crypto/src/Llib/util.scm", 64 );
DEFINE_STRING( BGl_string1714z00zz__cryptozd2utilzd2, BgL_bgl_string1714za700za7za7_1763za7, "&bignum-bit-length", 18 );
DEFINE_STRING( BGl_string1715z00zz__cryptozd2utilzd2, BgL_bgl_string1715za700za7za7_1764za7, "bignum", 6 );
DEFINE_STRING( BGl_string1716z00zz__cryptozd2utilzd2, BgL_bgl_string1716za700za7za7_1765za7, "&/ceilingfx", 11 );
DEFINE_STRING( BGl_string1717z00zz__cryptozd2utilzd2, BgL_bgl_string1717za700za7za7_1766za7, "bint", 4 );
DEFINE_STRING( BGl_string1718z00zz__cryptozd2utilzd2, BgL_bgl_string1718za700za7za7_1767za7, "bignum->char", 12 );
DEFINE_STRING( BGl_string1719z00zz__cryptozd2utilzd2, BgL_bgl_string1719za700za7za7_1768za7, "bignum must be < 256", 20 );
DEFINE_STRING( BGl_string1720z00zz__cryptozd2utilzd2, BgL_bgl_string1720za700za7za7_1769za7, "&bignum->char", 13 );
DEFINE_STRING( BGl_string1721z00zz__cryptozd2utilzd2, BgL_bgl_string1721za700za7za7_1770za7, "&char->bignum", 13 );
DEFINE_STRING( BGl_string1722z00zz__cryptozd2utilzd2, BgL_bgl_string1722za700za7za7_1771za7, "bchar", 5 );
DEFINE_STRING( BGl_string1723z00zz__cryptozd2utilzd2, BgL_bgl_string1723za700za7za7_1772za7, "&bin-str->bignum", 16 );
DEFINE_STRING( BGl_string1724z00zz__cryptozd2utilzd2, BgL_bgl_string1724za700za7za7_1773za7, "bstring", 7 );
DEFINE_STRING( BGl_string1725z00zz__cryptozd2utilzd2, BgL_bgl_string1725za700za7za7_1774za7, "_bignum->bin-str", 16 );
DEFINE_STRING( BGl_string1726z00zz__cryptozd2utilzd2, BgL_bgl_string1726za700za7za7_1775za7, "_bignum->bin-str!", 17 );
DEFINE_STRING( BGl_string1727z00zz__cryptozd2utilzd2, BgL_bgl_string1727za700za7za7_1776za7, "bignum->bin-str!", 16 );
DEFINE_STRING( BGl_string1728z00zz__cryptozd2utilzd2, BgL_bgl_string1728za700za7za7_1777za7, "integer too large", 17 );
DEFINE_STRING( BGl_string1729z00zz__cryptozd2utilzd2, BgL_bgl_string1729za700za7za7_1778za7, "wrong number of arguments: [1..2] expected, provided", 52 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sha256sumzd2binzd2envz00zz__cryptozd2utilzd2, BgL_bgl_za762sha256sumza7d2b1779z00, BGl_z62sha256sumzd2binzb0zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1730z00zz__cryptozd2utilzd2, BgL_bgl_string1730za700za7za7_1780za7, "Illegal keyword argument", 24 );
DEFINE_STRING( BGl_string1731z00zz__cryptozd2utilzd2, BgL_bgl_string1731za700za7za7_1781za7, "_make-random-string", 19 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_hexzd2strzd2ze3stringzd2envz31zz__cryptozd2utilzd2, BgL_bgl_za762hexza7d2strza7d2za71782z00, BGl_z62hexzd2strzd2ze3stringz81zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_STRING( BGl_string1732z00zz__cryptozd2utilzd2, BgL_bgl_string1732za700za7za7_1783za7, "/dev/urandom", 12 );
DEFINE_STRING( BGl_string1733z00zz__cryptozd2utilzd2, BgL_bgl_string1733za700za7za7_1784za7, "/dev/random did not work", 24 );
DEFINE_STRING( BGl_string1734z00zz__cryptozd2utilzd2, BgL_bgl_string1734za700za7za7_1785za7, "_make-random-bignum", 19 );
DEFINE_STRING( BGl_string1735z00zz__cryptozd2utilzd2, BgL_bgl_string1735za700za7za7_1786za7, "&char-xor", 9 );
DEFINE_STRING( BGl_string1736z00zz__cryptozd2utilzd2, BgL_bgl_string1736za700za7za7_1787za7, "string-xor", 10 );
DEFINE_STRING( BGl_string1737z00zz__cryptozd2utilzd2, BgL_bgl_string1737za700za7za7_1788za7, "strings don't have same length", 30 );
DEFINE_STRING( BGl_string1738z00zz__cryptozd2utilzd2, BgL_bgl_string1738za700za7za7_1789za7, "&string-xor", 11 );
DEFINE_STRING( BGl_string1739z00zz__cryptozd2utilzd2, BgL_bgl_string1739za700za7za7_1790za7, "--", 2 );
DEFINE_STRING( BGl_string1740z00zz__cryptozd2utilzd2, BgL_bgl_string1740za700za7za7_1791za7, "", 0 );
DEFINE_STRING( BGl_string1741z00zz__cryptozd2utilzd2, BgL_bgl_string1741za700za7za7_1792za7, "&str->hex-string", 16 );
DEFINE_STRING( BGl_string1742z00zz__cryptozd2utilzd2, BgL_bgl_string1742za700za7za7_1793za7, "&hex-str->string", 16 );
DEFINE_STRING( BGl_string1743z00zz__cryptozd2utilzd2, BgL_bgl_string1743za700za7za7_1794za7, "&hex-str->string!", 17 );
DEFINE_STRING( BGl_string1744z00zz__cryptozd2utilzd2, BgL_bgl_string1744za700za7za7_1795za7, "internal error, numbers are not relatively prime", 48 );
DEFINE_STRING( BGl_string1745z00zz__cryptozd2utilzd2, BgL_bgl_string1745za700za7za7_1796za7, "wrong number of arguments: [2..3] expected, provided", 52 );
DEFINE_STRING( BGl_string1746z00zz__cryptozd2utilzd2, BgL_bgl_string1746za700za7za7_1797za7, "_make-random-prime", 18 );
DEFINE_STRING( BGl_string1747z00zz__cryptozd2utilzd2, BgL_bgl_string1747za700za7za7_1798za7, ".", 1 );
DEFINE_STRING( BGl_string1748z00zz__cryptozd2utilzd2, BgL_bgl_string1748za700za7za7_1799za7, "+", 1 );
DEFINE_STRING( BGl_string1749z00zz__cryptozd2utilzd2, BgL_bgl_string1749za700za7za7_1800za7, "make-random-prime #z2 mod-inverse #z1 make-random-bignum :show-trace (:show-trace) make-random-string #z0 #z256 ", 112 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_makezd2randomzd2bignumzd2envzd2zz__cryptozd2utilzd2, BgL_bgl__makeza7d2randomza7d1801z00, opt_generic_entry, BGl__makezd2randomzd2bignumz00zz__cryptozd2utilzd2, BFALSE, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_zf2ceilingfxzd2envz20zz__cryptozd2utilzd2, BgL_bgl_za762za7f2ceilingfxza71802za7, BGl_z62zf2ceilingfxz90zz__cryptozd2utilzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_charzd2xorzd2envz00zz__cryptozd2utilzd2, BgL_bgl_za762charza7d2xorza7b01803za7, BGl_z62charzd2xorzb0zz__cryptozd2utilzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_stringzd2xorzd2bufferz12zd2envzc0zz__cryptozd2utilzd2, BgL_bgl_za762stringza7d2xorza71804za7, BGl_z62stringzd2xorzd2bufferz12z70zz__cryptozd2utilzd2, 0L, BUNSPEC, 7 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_makezd2randomzd2stringzd2envzd2zz__cryptozd2utilzd2, BgL_bgl__makeza7d2randomza7d1805z00, opt_generic_entry, BGl__makezd2randomzd2stringz00zz__cryptozd2utilzd2, BFALSE, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_sha512sumzd2binzd2envz00zz__cryptozd2utilzd2, BgL_bgl_za762sha512sumza7d2b1806z00, BGl_z62sha512sumzd2binzb0zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_stringzd2xorzd2envz00zz__cryptozd2utilzd2, BgL_bgl_za762stringza7d2xorza71807za7, BGl_z62stringzd2xorzb0zz__cryptozd2utilzd2, 0L, BUNSPEC, 2 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_bignumzd2ze3binzd2strz12zd2envz23zz__cryptozd2utilzd2, BgL_bgl__bignumza7d2za7e3bin1808z00, opt_generic_entry, BGl__bignumzd2ze3binzd2strz12zf1zz__cryptozd2utilzd2, BFALSE, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_makezd2randomzd2primezd2envzd2zz__cryptozd2utilzd2, BgL_bgl__makeza7d2randomza7d1809z00, opt_generic_entry, BGl__makezd2randomzd2primez00zz__cryptozd2utilzd2, BFALSE, -1 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_exptzd2modbxzd2envz00zz__cryptozd2utilzd2, BgL_bgl_za762exptza7d2modbxza71810za7, BGl_z62exptzd2modbxzb0zz__cryptozd2utilzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_stringzd2xorz12zd2envz12zz__cryptozd2utilzd2, BgL_bgl_za762stringza7d2xorza71811za7, BGl_z62stringzd2xorz12za2zz__cryptozd2utilzd2, 0L, BUNSPEC, 3 );
DEFINE_EXPORT_BGL_PROCEDURE( BGl_binzd2strzd2ze3bignumzd2envz31zz__cryptozd2utilzd2, BgL_bgl_za762binza7d2strza7d2za71812z00, BGl_z62binzd2strzd2ze3bignumz81zz__cryptozd2utilzd2, 0L, BUNSPEC, 1 );

/* GC roots registration */
static obj_t bgl_gc_roots_register() {
#if defined( BGL_GC_ROOTS )
#define ADD_ROOT( addr ) (addr > roots_max ? roots_max = addr : (addr < roots_min ? roots_min = addr : 0))
void *roots_min = (void*)ULONG_MAX, *roots_max = 0;
ADD_ROOT( (void *)(&BGl_requirezd2initializa7ationz75zz__cryptozd2utilzd2) );
#undef ADD_ROOT
if( roots_max > 0 ) GC_add_roots( roots_min, ((void **)roots_max) + 1 );
#endif
return BUNSPEC;
}



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__cryptozd2utilzd2(long BgL_checksumz00_1120, char * BgL_fromz00_1121)
{
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__cryptozd2utilzd2))
{ 
BGl_requirezd2initializa7ationz75zz__cryptozd2utilzd2 = 
BBOOL(((bool_t)0)); 
BGl_gczd2rootszd2initz00zz__cryptozd2utilzd2(); 
BGl_libraryzd2moduleszd2initz00zz__cryptozd2utilzd2(); 
BGl_cnstzd2initzd2zz__cryptozd2utilzd2(); 
return 
BGl_methodzd2initzd2zz__cryptozd2utilzd2();}  else 
{ 
return BUNSPEC;} } 

}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__cryptozd2utilzd2()
{
{ /* Llib/util.scm 1 */
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__sha2z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__md5z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__sha1z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__r4_input_6_10_2z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__base64z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__bitz00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__crypto-util"); 
BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)0), "__crypto-util"); 
return BUNSPEC;} 

}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__cryptozd2utilzd2()
{
{ /* Llib/util.scm 1 */
{ /* Llib/util.scm 1 */
 obj_t BgL_cportz00_1092;
{ /* Llib/util.scm 1 */
 obj_t BgL_stringz00_1100;
BgL_stringz00_1100 = BGl_string1749z00zz__cryptozd2utilzd2; 
{ /* Llib/util.scm 1 */
 obj_t BgL_startz00_1101;
BgL_startz00_1101 = 
BINT(((long)0)); 
{ /* Llib/util.scm 1 */
 obj_t BgL_endz00_1102;
BgL_endz00_1102 = 
BINT(
STRING_LENGTH(
((obj_t)BgL_stringz00_1100))); 
{ /* Llib/util.scm 1 */

BgL_cportz00_1092 = 
BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(BgL_stringz00_1100, BgL_startz00_1101, BgL_endz00_1102); } } } } 
{ 
 long BgL_iz00_1093;
BgL_iz00_1093 = ((long)9); 
BgL_loopz00_1094:
if(
(BgL_iz00_1093==((long)-1)))
{ /* Llib/util.scm 1 */
return BUNSPEC;}  else 
{ /* Llib/util.scm 1 */
{ /* Llib/util.scm 1 */
 obj_t BgL_arg1751z00_1096;
{ /* Llib/util.scm 1 */

{ /* Llib/util.scm 1 */
 obj_t BgL_locationz00_1098;
BgL_locationz00_1098 = 
BBOOL(((bool_t)0)); 
{ /* Llib/util.scm 1 */

BgL_arg1751z00_1096 = 
BGl_readz00zz__readerz00(BgL_cportz00_1092, BgL_locationz00_1098); } } } 
{ /* Llib/util.scm 1 */
 int BgL_tmpz00_1154;
BgL_tmpz00_1154 = 
(int)(BgL_iz00_1093); 
CNST_TABLE_SET(BgL_tmpz00_1154, BgL_arg1751z00_1096); } } 
{ /* Llib/util.scm 1 */
 int BgL_auxz00_1099;
BgL_auxz00_1099 = 
(int)(
(BgL_iz00_1093-((long)1))); 
{ 
 long BgL_iz00_1159;
BgL_iz00_1159 = 
(long)(BgL_auxz00_1099); 
BgL_iz00_1093 = BgL_iz00_1159; 
goto BgL_loopz00_1094;} } } } } } 

}



/* gc-roots-init */
obj_t BGl_gczd2rootszd2initz00zz__cryptozd2utilzd2()
{
{ /* Llib/util.scm 1 */
return 
bgl_gc_roots_register();} 

}



/* bignum-bit-length */
BGL_EXPORTED_DEF long BGl_bignumzd2bitzd2lengthz00zz__cryptozd2utilzd2(obj_t BgL_bz00_3)
{
{ /* Llib/util.scm 41 */
{ 
 obj_t BgL_bz00_70; long BgL_resz00_71;
BgL_bz00_70 = BgL_bz00_3; 
BgL_resz00_71 = ((long)0); 
BgL_zc3z04anonymousza31068ze3z87_72:
{ /* Llib/util.scm 44 */
 obj_t BgL_dividedz00_73;
BgL_dividedz00_73 = 
bgl_bignum_quotient(BgL_bz00_70, 
CNST_TABLE_REF(((long)0))); 
if(
BXZERO(BgL_bz00_70))
{ /* Llib/util.scm 46 */
return BgL_resz00_71;}  else 
{ /* Llib/util.scm 46 */
if(
BXZERO(BgL_dividedz00_73))
{ /* Llib/util.scm 48 */
 long BgL_xz00_76;
BgL_xz00_76 = 
bgl_bignum_to_long(BgL_bz00_70); 
if(
(BgL_xz00_76<((long)2)))
{ /* Llib/util.scm 50 */
return 
(BgL_resz00_71+((long)1));}  else 
{ /* Llib/util.scm 50 */
if(
(BgL_xz00_76<((long)4)))
{ /* Llib/util.scm 51 */
return 
(BgL_resz00_71+((long)2));}  else 
{ /* Llib/util.scm 51 */
if(
(BgL_xz00_76<((long)8)))
{ /* Llib/util.scm 52 */
return 
(BgL_resz00_71+((long)3));}  else 
{ /* Llib/util.scm 52 */
if(
(BgL_xz00_76<((long)16)))
{ /* Llib/util.scm 53 */
return 
(BgL_resz00_71+((long)4));}  else 
{ /* Llib/util.scm 53 */
if(
(BgL_xz00_76<((long)32)))
{ /* Llib/util.scm 54 */
return 
(BgL_resz00_71+((long)5));}  else 
{ /* Llib/util.scm 54 */
if(
(BgL_xz00_76<((long)64)))
{ /* Llib/util.scm 55 */
return 
(BgL_resz00_71+((long)6));}  else 
{ /* Llib/util.scm 55 */
if(
(BgL_xz00_76<((long)128)))
{ /* Llib/util.scm 56 */
return 
(BgL_resz00_71+((long)7));}  else 
{ /* Llib/util.scm 56 */
return 
(BgL_resz00_71+((long)8));} } } } } } } }  else 
{ 
 long BgL_resz00_1192; obj_t BgL_bz00_1191;
BgL_bz00_1191 = BgL_dividedz00_73; 
BgL_resz00_1192 = 
(BgL_resz00_71+((long)8)); 
BgL_resz00_71 = BgL_resz00_1192; 
BgL_bz00_70 = BgL_bz00_1191; 
goto BgL_zc3z04anonymousza31068ze3z87_72;} } } } } 

}



/* &bignum-bit-length */
obj_t BGl_z62bignumzd2bitzd2lengthz62zz__cryptozd2utilzd2(obj_t BgL_envz00_971, obj_t BgL_bz00_972)
{
{ /* Llib/util.scm 41 */
{ /* Llib/util.scm 44 */
 long BgL_tmpz00_1194;
{ /* Llib/util.scm 44 */
 obj_t BgL_auxz00_1195;
if(
BIGNUMP(BgL_bz00_972))
{ /* Llib/util.scm 44 */
BgL_auxz00_1195 = BgL_bz00_972
; }  else 
{ 
 obj_t BgL_auxz00_1198;
BgL_auxz00_1198 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)1506)), BGl_string1714z00zz__cryptozd2utilzd2, BGl_string1715z00zz__cryptozd2utilzd2, BgL_bz00_972); 
FAILURE(BgL_auxz00_1198,BFALSE,BFALSE);} 
BgL_tmpz00_1194 = 
BGl_bignumzd2bitzd2lengthz00zz__cryptozd2utilzd2(BgL_auxz00_1195); } 
return 
BINT(BgL_tmpz00_1194);} } 

}



/* /ceilingfx */
BGL_EXPORTED_DEF long BGl_zf2ceilingfxzf2zz__cryptozd2utilzd2(long BgL_xz00_4, long BgL_yz00_5)
{
{ /* Llib/util.scm 61 */
{ /* Llib/util.scm 62 */
 long BgL_qz00_1104; long BgL_rz00_1105;
BgL_qz00_1104 = 
(BgL_xz00_4/BgL_yz00_5); 
BgL_rz00_1105 = 
(BgL_xz00_4%BgL_yz00_5); 
if(
(BgL_rz00_1105==((long)0)))
{ /* Llib/util.scm 65 */
return BgL_qz00_1104;}  else 
{ /* Llib/util.scm 65 */
if(
(BgL_rz00_1105>((long)0)))
{ /* Llib/util.scm 66 */
return 
(BgL_qz00_1104+((long)1));}  else 
{ /* Llib/util.scm 66 */
return 
(BgL_qz00_1104-((long)1));} } } } 

}



/* &/ceilingfx */
obj_t BGl_z62zf2ceilingfxz90zz__cryptozd2utilzd2(obj_t BgL_envz00_973, obj_t BgL_xz00_974, obj_t BgL_yz00_975)
{
{ /* Llib/util.scm 61 */
{ /* Llib/util.scm 62 */
 long BgL_tmpz00_1212;
{ /* Llib/util.scm 62 */
 long BgL_auxz00_1222; long BgL_auxz00_1213;
{ /* Llib/util.scm 62 */
 obj_t BgL_tmpz00_1223;
if(
INTEGERP(BgL_yz00_975))
{ /* Llib/util.scm 62 */
BgL_tmpz00_1223 = BgL_yz00_975
; }  else 
{ 
 obj_t BgL_auxz00_1226;
BgL_auxz00_1226 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)1998)), BGl_string1716z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_yz00_975); 
FAILURE(BgL_auxz00_1226,BFALSE,BFALSE);} 
BgL_auxz00_1222 = 
(long)CINT(BgL_tmpz00_1223); } 
{ /* Llib/util.scm 62 */
 obj_t BgL_tmpz00_1214;
if(
INTEGERP(BgL_xz00_974))
{ /* Llib/util.scm 62 */
BgL_tmpz00_1214 = BgL_xz00_974
; }  else 
{ 
 obj_t BgL_auxz00_1217;
BgL_auxz00_1217 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)1998)), BGl_string1716z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_xz00_974); 
FAILURE(BgL_auxz00_1217,BFALSE,BFALSE);} 
BgL_auxz00_1213 = 
(long)CINT(BgL_tmpz00_1214); } 
BgL_tmpz00_1212 = 
BGl_zf2ceilingfxzf2zz__cryptozd2utilzd2(BgL_auxz00_1213, BgL_auxz00_1222); } 
return 
BINT(BgL_tmpz00_1212);} } 

}



/* bignum->char */
BGL_EXPORTED_DEF unsigned char BGl_bignumzd2ze3charz31zz__cryptozd2utilzd2(obj_t BgL_bz00_6)
{
{ /* Llib/util.scm 69 */
if(
(
(long)(
bgl_bignum_cmp(BgL_bz00_6, 
CNST_TABLE_REF(((long)0))))<((long)0)))
{ /* Llib/util.scm 70 */BFALSE; }  else 
{ /* Llib/util.scm 70 */
BGl_errorz00zz__errorz00(BGl_string1718z00zz__cryptozd2utilzd2, BGl_string1719z00zz__cryptozd2utilzd2, BgL_bz00_6); } 
{ /* Llib/util.scm 72 */
 long BgL_arg1084z00_1106;
BgL_arg1084z00_1106 = 
bgl_bignum_to_long(BgL_bz00_6); 
return 
(char)(
(BgL_arg1084z00_1106));} } 

}



/* &bignum->char */
obj_t BGl_z62bignumzd2ze3charz53zz__cryptozd2utilzd2(obj_t BgL_envz00_976, obj_t BgL_bz00_977)
{
{ /* Llib/util.scm 69 */
{ /* Llib/util.scm 71 */
 unsigned char BgL_tmpz00_1242;
{ /* Llib/util.scm 71 */
 obj_t BgL_auxz00_1243;
if(
BIGNUMP(BgL_bz00_977))
{ /* Llib/util.scm 71 */
BgL_auxz00_1243 = BgL_bz00_977
; }  else 
{ 
 obj_t BgL_auxz00_1246;
BgL_auxz00_1246 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2264)), BGl_string1720z00zz__cryptozd2utilzd2, BGl_string1715z00zz__cryptozd2utilzd2, BgL_bz00_977); 
FAILURE(BgL_auxz00_1246,BFALSE,BFALSE);} 
BgL_tmpz00_1242 = 
BGl_bignumzd2ze3charz31zz__cryptozd2utilzd2(BgL_auxz00_1243); } 
return 
BCHAR(BgL_tmpz00_1242);} } 

}



/* char->bignum */
BGL_EXPORTED_DEF obj_t BGl_charzd2ze3bignumz31zz__cryptozd2utilzd2(unsigned char BgL_cz00_7)
{
{ /* Llib/util.scm 73 */
return 
bgl_long_to_bignum(
(
(unsigned char)(BgL_cz00_7)));} 

}



/* &char->bignum */
obj_t BGl_z62charzd2ze3bignumz53zz__cryptozd2utilzd2(obj_t BgL_envz00_978, obj_t BgL_cz00_979)
{
{ /* Llib/util.scm 73 */
{ /* Llib/util.scm 74 */
 unsigned char BgL_auxz00_1255;
{ /* Llib/util.scm 74 */
 obj_t BgL_tmpz00_1256;
if(
CHARP(BgL_cz00_979))
{ /* Llib/util.scm 74 */
BgL_tmpz00_1256 = BgL_cz00_979
; }  else 
{ 
 obj_t BgL_auxz00_1259;
BgL_auxz00_1259 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2373)), BGl_string1721z00zz__cryptozd2utilzd2, BGl_string1722z00zz__cryptozd2utilzd2, BgL_cz00_979); 
FAILURE(BgL_auxz00_1259,BFALSE,BFALSE);} 
BgL_auxz00_1255 = 
CCHAR(BgL_tmpz00_1256); } 
return 
BGl_charzd2ze3bignumz31zz__cryptozd2utilzd2(BgL_auxz00_1255);} } 

}



/* bin-str->bignum */
BGL_EXPORTED_DEF obj_t BGl_binzd2strzd2ze3bignumze3zz__cryptozd2utilzd2(obj_t BgL_strz00_8)
{
{ /* Llib/util.scm 75 */
{ 
 long BgL_iz00_504; obj_t BgL_resz00_505;
BgL_iz00_504 = ((long)0); 
BgL_resz00_505 = 
CNST_TABLE_REF(((long)1)); 
BgL_loopz00_503:
if(
(BgL_iz00_504==
STRING_LENGTH(BgL_strz00_8)))
{ /* Llib/util.scm 78 */
return BgL_resz00_505;}  else 
{ 
 obj_t BgL_resz00_1270; long BgL_iz00_1268;
BgL_iz00_1268 = 
(BgL_iz00_504+((long)1)); 
BgL_resz00_1270 = 
bgl_bignum_add(
bgl_bignum_mul(BgL_resz00_505, 
CNST_TABLE_REF(((long)0))), 
bgl_long_to_bignum(
(
STRING_REF(BgL_strz00_8, BgL_iz00_504)))); 
BgL_resz00_505 = BgL_resz00_1270; 
BgL_iz00_504 = BgL_iz00_1268; 
goto BgL_loopz00_503;} } } 

}



/* &bin-str->bignum */
obj_t BGl_z62binzd2strzd2ze3bignumz81zz__cryptozd2utilzd2(obj_t BgL_envz00_980, obj_t BgL_strz00_981)
{
{ /* Llib/util.scm 75 */
{ /* Llib/util.scm 76 */
 obj_t BgL_auxz00_1278;
if(
STRINGP(BgL_strz00_981))
{ /* Llib/util.scm 76 */
BgL_auxz00_1278 = BgL_strz00_981
; }  else 
{ 
 obj_t BgL_auxz00_1281;
BgL_auxz00_1281 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2443)), BGl_string1723z00zz__cryptozd2utilzd2, BGl_string1724z00zz__cryptozd2utilzd2, BgL_strz00_981); 
FAILURE(BgL_auxz00_1281,BFALSE,BFALSE);} 
return 
BGl_binzd2strzd2ze3bignumze3zz__cryptozd2utilzd2(BgL_auxz00_1278);} } 

}



/* _bignum->bin-str */
obj_t BGl__bignumzd2ze3binzd2strze3zz__cryptozd2utilzd2(obj_t BgL_env1037z00_12, obj_t BgL_opt1036z00_11)
{
{ /* Llib/util.scm 83 */
{ /* Llib/util.scm 83 */
 obj_t BgL_bz00_107;
BgL_bz00_107 = 
VECTOR_REF(BgL_opt1036z00_11,((long)0)); 
switch( 
VECTOR_LENGTH(BgL_opt1036z00_11)) { case ((long)1) : 

{ /* Llib/util.scm 83 */

{ /* Llib/util.scm 83 */
 obj_t BgL_auxz00_1287;
if(
BIGNUMP(BgL_bz00_107))
{ /* Llib/util.scm 83 */
BgL_auxz00_1287 = BgL_bz00_107
; }  else 
{ 
 obj_t BgL_auxz00_1290;
BgL_auxz00_1290 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2629)), BGl_string1725z00zz__cryptozd2utilzd2, BGl_string1715z00zz__cryptozd2utilzd2, BgL_bz00_107); 
FAILURE(BgL_auxz00_1290,BFALSE,BFALSE);} 
return 
BGl_bignumzd2ze3binzd2strze3zz__cryptozd2utilzd2(BgL_auxz00_1287, ((long)-1));} } break;case ((long)2) : 

{ /* Llib/util.scm 83 */
 obj_t BgL_lenz00_112;
BgL_lenz00_112 = 
VECTOR_REF(BgL_opt1036z00_11,((long)1)); 
{ /* Llib/util.scm 83 */

{ /* Llib/util.scm 83 */
 long BgL_auxz00_1303; obj_t BgL_auxz00_1296;
{ /* Llib/util.scm 83 */
 obj_t BgL_tmpz00_1304;
if(
INTEGERP(BgL_lenz00_112))
{ /* Llib/util.scm 83 */
BgL_tmpz00_1304 = BgL_lenz00_112
; }  else 
{ 
 obj_t BgL_auxz00_1307;
BgL_auxz00_1307 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2629)), BGl_string1725z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_lenz00_112); 
FAILURE(BgL_auxz00_1307,BFALSE,BFALSE);} 
BgL_auxz00_1303 = 
(long)CINT(BgL_tmpz00_1304); } 
if(
BIGNUMP(BgL_bz00_107))
{ /* Llib/util.scm 83 */
BgL_auxz00_1296 = BgL_bz00_107
; }  else 
{ 
 obj_t BgL_auxz00_1299;
BgL_auxz00_1299 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2629)), BGl_string1725z00zz__cryptozd2utilzd2, BGl_string1715z00zz__cryptozd2utilzd2, BgL_bz00_107); 
FAILURE(BgL_auxz00_1299,BFALSE,BFALSE);} 
return 
BGl_bignumzd2ze3binzd2strze3zz__cryptozd2utilzd2(BgL_auxz00_1296, BgL_auxz00_1303);} } } break;
default: 
return BUNSPEC;} } } 

}



/* bignum->bin-str */
BGL_EXPORTED_DEF obj_t BGl_bignumzd2ze3binzd2strze3zz__cryptozd2utilzd2(obj_t BgL_bz00_9, long BgL_lenz00_10)
{
{ /* Llib/util.scm 83 */
{ /* Llib/util.scm 84 */
 long BgL_lenz00_113;
if(
(BgL_lenz00_10==((long)-1)))
{ /* Llib/util.scm 85 */
 long BgL_res1636z00_539;
{ /* Llib/util.scm 85 */
 long BgL_xz00_527;
BgL_xz00_527 = 
BGl_bignumzd2bitzd2lengthz00zz__cryptozd2utilzd2(BgL_bz00_9); 
{ /* Llib/util.scm 62 */
 long BgL_qz00_528; long BgL_rz00_529;
BgL_qz00_528 = 
(BgL_xz00_527/((long)8)); 
BgL_rz00_529 = 
(BgL_xz00_527%((long)8)); 
if(
(BgL_rz00_529==((long)0)))
{ /* Llib/util.scm 65 */
BgL_res1636z00_539 = BgL_qz00_528; }  else 
{ /* Llib/util.scm 65 */
if(
(BgL_rz00_529>((long)0)))
{ /* Llib/util.scm 66 */
BgL_res1636z00_539 = 
(BgL_qz00_528+((long)1)); }  else 
{ /* Llib/util.scm 66 */
BgL_res1636z00_539 = 
(BgL_qz00_528-((long)1)); } } } } 
BgL_lenz00_113 = BgL_res1636z00_539; }  else 
{ /* Llib/util.scm 84 */
BgL_lenz00_113 = BgL_lenz00_10; } 
{ /* Llib/util.scm 84 */
 obj_t BgL_strz00_114;
{ /* Llib/util.scm 87 */

BgL_strz00_114 = 
make_string(BgL_lenz00_113, ((unsigned char)' ')); } 
{ /* Llib/util.scm 87 */

BGl_bignumzd2ze3binzd2strz12zf1zz__cryptozd2utilzd2(BgL_strz00_114, ((long)0), BgL_bz00_9, BgL_lenz00_113); 
return BgL_strz00_114;} } } } 

}



/* _bignum->bin-str! */
obj_t BGl__bignumzd2ze3binzd2strz12zf1zz__cryptozd2utilzd2(obj_t BgL_env1041z00_18, obj_t BgL_opt1040z00_17)
{
{ /* Llib/util.scm 90 */
{ /* Llib/util.scm 90 */
 obj_t BgL_bufferz00_119; obj_t BgL_atz00_120; obj_t BgL_xz00_121;
BgL_bufferz00_119 = 
VECTOR_REF(BgL_opt1040z00_17,((long)0)); 
BgL_atz00_120 = 
VECTOR_REF(BgL_opt1040z00_17,((long)1)); 
BgL_xz00_121 = 
VECTOR_REF(BgL_opt1040z00_17,((long)2)); 
switch( 
VECTOR_LENGTH(BgL_opt1040z00_17)) { case ((long)3) : 

{ /* Llib/util.scm 90 */

{ /* Llib/util.scm 90 */
 obj_t BgL_auxz00_1347; long BgL_auxz00_1338; obj_t BgL_auxz00_1331;
if(
BIGNUMP(BgL_xz00_121))
{ /* Llib/util.scm 90 */
BgL_auxz00_1347 = BgL_xz00_121
; }  else 
{ 
 obj_t BgL_auxz00_1350;
BgL_auxz00_1350 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2862)), BGl_string1726z00zz__cryptozd2utilzd2, BGl_string1715z00zz__cryptozd2utilzd2, BgL_xz00_121); 
FAILURE(BgL_auxz00_1350,BFALSE,BFALSE);} 
{ /* Llib/util.scm 90 */
 obj_t BgL_tmpz00_1339;
if(
INTEGERP(BgL_atz00_120))
{ /* Llib/util.scm 90 */
BgL_tmpz00_1339 = BgL_atz00_120
; }  else 
{ 
 obj_t BgL_auxz00_1342;
BgL_auxz00_1342 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2862)), BGl_string1726z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_atz00_120); 
FAILURE(BgL_auxz00_1342,BFALSE,BFALSE);} 
BgL_auxz00_1338 = 
(long)CINT(BgL_tmpz00_1339); } 
if(
STRINGP(BgL_bufferz00_119))
{ /* Llib/util.scm 90 */
BgL_auxz00_1331 = BgL_bufferz00_119
; }  else 
{ 
 obj_t BgL_auxz00_1334;
BgL_auxz00_1334 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2862)), BGl_string1726z00zz__cryptozd2utilzd2, BGl_string1724z00zz__cryptozd2utilzd2, BgL_bufferz00_119); 
FAILURE(BgL_auxz00_1334,BFALSE,BFALSE);} 
return 
BGl_bignumzd2ze3binzd2strz12zf1zz__cryptozd2utilzd2(BgL_auxz00_1331, BgL_auxz00_1338, BgL_auxz00_1347, ((long)-1));} } break;case ((long)4) : 

{ /* Llib/util.scm 90 */
 obj_t BgL_lenz00_126;
BgL_lenz00_126 = 
VECTOR_REF(BgL_opt1040z00_17,((long)3)); 
{ /* Llib/util.scm 90 */

{ /* Llib/util.scm 90 */
 long BgL_auxz00_1379; obj_t BgL_auxz00_1372; long BgL_auxz00_1363; obj_t BgL_auxz00_1356;
{ /* Llib/util.scm 90 */
 obj_t BgL_tmpz00_1380;
if(
INTEGERP(BgL_lenz00_126))
{ /* Llib/util.scm 90 */
BgL_tmpz00_1380 = BgL_lenz00_126
; }  else 
{ 
 obj_t BgL_auxz00_1383;
BgL_auxz00_1383 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2862)), BGl_string1726z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_lenz00_126); 
FAILURE(BgL_auxz00_1383,BFALSE,BFALSE);} 
BgL_auxz00_1379 = 
(long)CINT(BgL_tmpz00_1380); } 
if(
BIGNUMP(BgL_xz00_121))
{ /* Llib/util.scm 90 */
BgL_auxz00_1372 = BgL_xz00_121
; }  else 
{ 
 obj_t BgL_auxz00_1375;
BgL_auxz00_1375 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2862)), BGl_string1726z00zz__cryptozd2utilzd2, BGl_string1715z00zz__cryptozd2utilzd2, BgL_xz00_121); 
FAILURE(BgL_auxz00_1375,BFALSE,BFALSE);} 
{ /* Llib/util.scm 90 */
 obj_t BgL_tmpz00_1364;
if(
INTEGERP(BgL_atz00_120))
{ /* Llib/util.scm 90 */
BgL_tmpz00_1364 = BgL_atz00_120
; }  else 
{ 
 obj_t BgL_auxz00_1367;
BgL_auxz00_1367 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2862)), BGl_string1726z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_atz00_120); 
FAILURE(BgL_auxz00_1367,BFALSE,BFALSE);} 
BgL_auxz00_1363 = 
(long)CINT(BgL_tmpz00_1364); } 
if(
STRINGP(BgL_bufferz00_119))
{ /* Llib/util.scm 90 */
BgL_auxz00_1356 = BgL_bufferz00_119
; }  else 
{ 
 obj_t BgL_auxz00_1359;
BgL_auxz00_1359 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)2862)), BGl_string1726z00zz__cryptozd2utilzd2, BGl_string1724z00zz__cryptozd2utilzd2, BgL_bufferz00_119); 
FAILURE(BgL_auxz00_1359,BFALSE,BFALSE);} 
return 
BGl_bignumzd2ze3binzd2strz12zf1zz__cryptozd2utilzd2(BgL_auxz00_1356, BgL_auxz00_1363, BgL_auxz00_1372, BgL_auxz00_1379);} } } break;
default: 
return BUNSPEC;} } } 

}



/* bignum->bin-str! */
BGL_EXPORTED_DEF obj_t BGl_bignumzd2ze3binzd2strz12zf1zz__cryptozd2utilzd2(obj_t BgL_bufferz00_13, long BgL_atz00_14, obj_t BgL_xz00_15, long BgL_lenz00_16)
{
{ /* Llib/util.scm 90 */
{ /* Llib/util.scm 95 */
 long BgL_lenz00_128;
if(
(BgL_lenz00_16==((long)-1)))
{ /* Llib/util.scm 96 */
 long BgL_res1637z00_560;
{ /* Llib/util.scm 96 */
 long BgL_xz00_548;
BgL_xz00_548 = 
BGl_bignumzd2bitzd2lengthz00zz__cryptozd2utilzd2(BgL_xz00_15); 
{ /* Llib/util.scm 62 */
 long BgL_qz00_549; long BgL_rz00_550;
BgL_qz00_549 = 
(BgL_xz00_548/((long)8)); 
BgL_rz00_550 = 
(BgL_xz00_548%((long)8)); 
if(
(BgL_rz00_550==((long)0)))
{ /* Llib/util.scm 65 */
BgL_res1637z00_560 = BgL_qz00_549; }  else 
{ /* Llib/util.scm 65 */
if(
(BgL_rz00_550>((long)0)))
{ /* Llib/util.scm 66 */
BgL_res1637z00_560 = 
(BgL_qz00_549+((long)1)); }  else 
{ /* Llib/util.scm 66 */
BgL_res1637z00_560 = 
(BgL_qz00_549-((long)1)); } } } } 
BgL_lenz00_128 = BgL_res1637z00_560; }  else 
{ /* Llib/util.scm 95 */
BgL_lenz00_128 = BgL_lenz00_16; } 
{ /* Llib/util.scm 98 */
 long BgL_g1019z00_129;
BgL_g1019z00_129 = 
(BgL_lenz00_128-((long)1)); 
{ 
 obj_t BgL_xz00_131; long BgL_iz00_132;
BgL_xz00_131 = BgL_xz00_15; 
BgL_iz00_132 = BgL_g1019z00_129; 
BgL_zc3z04anonymousza31114ze3z87_133:
{ /* Llib/util.scm 101 */
 bool_t BgL_test1850z00_1403;
if(
(BgL_iz00_132<((long)0)))
{ /* Llib/util.scm 101 */
BgL_test1850z00_1403 = 
BXZERO(BgL_xz00_131)
; }  else 
{ /* Llib/util.scm 101 */
BgL_test1850z00_1403 = ((bool_t)0)
; } 
if(BgL_test1850z00_1403)
{ /* Llib/util.scm 101 */
return BgL_bufferz00_13;}  else 
{ /* Llib/util.scm 101 */
if(
(BgL_iz00_132<((long)0)))
{ /* Llib/util.scm 104 */
return 
BGl_errorz00zz__errorz00(BGl_string1727z00zz__cryptozd2utilzd2, BGl_string1728z00zz__cryptozd2utilzd2, BgL_xz00_131);}  else 
{ /* Llib/util.scm 104 */
{ /* Llib/util.scm 107 */
 unsigned char BgL_auxz00_1412; long BgL_tmpz00_1410;
BgL_auxz00_1412 = 
(
bgl_bignum_to_long(
bgl_bignum_remainder(BgL_xz00_131, 
CNST_TABLE_REF(((long)0))))); 
BgL_tmpz00_1410 = 
(BgL_atz00_14+BgL_iz00_132); 
STRING_SET(BgL_bufferz00_13, BgL_tmpz00_1410, BgL_auxz00_1412); } 
{ 
 long BgL_iz00_1421; obj_t BgL_xz00_1418;
BgL_xz00_1418 = 
bgl_bignum_quotient(BgL_xz00_131, 
CNST_TABLE_REF(((long)0))); 
BgL_iz00_1421 = 
(BgL_iz00_132-((long)1)); 
BgL_iz00_132 = BgL_iz00_1421; 
BgL_xz00_131 = BgL_xz00_1418; 
goto BgL_zc3z04anonymousza31114ze3z87_133;} } } } } } } } 

}



/* _make-random-string */
obj_t BGl__makezd2randomzd2stringz00zz__cryptozd2utilzd2(obj_t BgL_env1045z00_22, obj_t BgL_opt1044z00_21)
{
{ /* Llib/util.scm 110 */
{ 
 obj_t BgL_k1z00_151; long BgL_iz00_152;
{ /* Llib/util.scm 110 */
 obj_t BgL_lenz00_154;
BgL_lenz00_154 = 
VECTOR_REF(BgL_opt1044z00_21,((long)0)); 
{ /* Llib/util.scm 110 */
 obj_t BgL_showzd2tracezd2_155;
BgL_showzd2tracezd2_155 = BFALSE; 
{ /* Llib/util.scm 110 */

{ 
 long BgL_iz00_156;
BgL_iz00_156 = ((long)1); 
BgL_check1048z00_157:
if(
(BgL_iz00_156==
VECTOR_LENGTH(BgL_opt1044z00_21)))
{ /* Llib/util.scm 110 */BNIL; }  else 
{ /* Llib/util.scm 110 */
 bool_t BgL_test1854z00_1427;
{ /* Llib/util.scm 110 */
 obj_t BgL_arg1143z00_163;
BgL_arg1143z00_163 = 
VECTOR_REF(BgL_opt1044z00_21,BgL_iz00_156); 
BgL_test1854z00_1427 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1143z00_163, 
CNST_TABLE_REF(((long)3)))); } 
if(BgL_test1854z00_1427)
{ 
 long BgL_iz00_1432;
BgL_iz00_1432 = 
(BgL_iz00_156+((long)2)); 
BgL_iz00_156 = BgL_iz00_1432; 
goto BgL_check1048z00_157;}  else 
{ /* Llib/util.scm 110 */
 obj_t BgL_arg1142z00_162;
BgL_arg1142z00_162 = 
VECTOR_REF(BgL_opt1044z00_21,BgL_iz00_156); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string1730z00zz__cryptozd2utilzd2, BgL_arg1142z00_162); } } } 
{ /* Llib/util.scm 110 */
 obj_t BgL_index1050z00_164;
BgL_k1z00_151 = 
CNST_TABLE_REF(((long)4)); 
BgL_iz00_152 = ((long)1); 
BgL_search1047z00_153:
if(
(BgL_iz00_152==
VECTOR_LENGTH(BgL_opt1044z00_21)))
{ /* Llib/util.scm 110 */
BgL_index1050z00_164 = 
BINT(((long)-1)); }  else 
{ /* Llib/util.scm 110 */
if(
(BgL_iz00_152==
(
VECTOR_LENGTH(BgL_opt1044z00_21)-((long)1))))
{ /* Llib/util.scm 110 */
BgL_index1050z00_164 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string1729z00zz__cryptozd2utilzd2, 
BINT(
VECTOR_LENGTH(BgL_opt1044z00_21))); }  else 
{ /* Llib/util.scm 110 */
 obj_t BgL_vz00_172;
BgL_vz00_172 = 
VECTOR_REF(BgL_opt1044z00_21,BgL_iz00_152); 
if(
(BgL_vz00_172==BgL_k1z00_151))
{ /* Llib/util.scm 110 */
BgL_index1050z00_164 = 
BINT(
(BgL_iz00_152+((long)1))); }  else 
{ 
 long BgL_iz00_1454;
BgL_iz00_1454 = 
(BgL_iz00_152+((long)2)); 
BgL_iz00_152 = BgL_iz00_1454; 
goto BgL_search1047z00_153;} } } 
{ /* Llib/util.scm 110 */
 bool_t BgL_test1858z00_1457;
{ /* Llib/util.scm 110 */
 long BgL_n1z00_595;
{ /* Llib/util.scm 110 */
 obj_t BgL_tmpz00_1458;
if(
INTEGERP(BgL_index1050z00_164))
{ /* Llib/util.scm 110 */
BgL_tmpz00_1458 = BgL_index1050z00_164
; }  else 
{ 
 obj_t BgL_auxz00_1461;
BgL_auxz00_1461 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)3436)), BGl_string1731z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_index1050z00_164); 
FAILURE(BgL_auxz00_1461,BFALSE,BFALSE);} 
BgL_n1z00_595 = 
(long)CINT(BgL_tmpz00_1458); } 
BgL_test1858z00_1457 = 
(BgL_n1z00_595>=((long)0)); } 
if(BgL_test1858z00_1457)
{ 
 long BgL_auxz00_1467;
{ /* Llib/util.scm 110 */
 obj_t BgL_tmpz00_1468;
if(
INTEGERP(BgL_index1050z00_164))
{ /* Llib/util.scm 110 */
BgL_tmpz00_1468 = BgL_index1050z00_164
; }  else 
{ 
 obj_t BgL_auxz00_1471;
BgL_auxz00_1471 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)3436)), BGl_string1731z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_index1050z00_164); 
FAILURE(BgL_auxz00_1471,BFALSE,BFALSE);} 
BgL_auxz00_1467 = 
(long)CINT(BgL_tmpz00_1468); } 
BgL_showzd2tracezd2_155 = 
VECTOR_REF(BgL_opt1044z00_21,BgL_auxz00_1467); }  else 
{ /* Llib/util.scm 110 */BFALSE; } } } 
{ /* Llib/util.scm 110 */
 obj_t BgL_arg1145z00_166;
BgL_arg1145z00_166 = 
VECTOR_REF(BgL_opt1044z00_21,((long)0)); 
{ /* Llib/util.scm 110 */
 obj_t BgL_showzd2tracezd2_167;
BgL_showzd2tracezd2_167 = BgL_showzd2tracezd2_155; 
{ /* Llib/util.scm 110 */
 long BgL_auxz00_1478;
{ /* Llib/util.scm 110 */
 obj_t BgL_tmpz00_1479;
if(
INTEGERP(BgL_arg1145z00_166))
{ /* Llib/util.scm 110 */
BgL_tmpz00_1479 = BgL_arg1145z00_166
; }  else 
{ 
 obj_t BgL_auxz00_1482;
BgL_auxz00_1482 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)3436)), BGl_string1731z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_arg1145z00_166); 
FAILURE(BgL_auxz00_1482,BFALSE,BFALSE);} 
BgL_auxz00_1478 = 
(long)CINT(BgL_tmpz00_1479); } 
return 
BGl_makezd2randomzd2stringz00zz__cryptozd2utilzd2(BgL_auxz00_1478, BgL_showzd2tracezd2_167);} } } } } } } } 

}



/* make-random-string */
BGL_EXPORTED_DEF obj_t BGl_makezd2randomzd2stringz00zz__cryptozd2utilzd2(long BgL_lenz00_19, obj_t BgL_showzd2tracezd2_20)
{
{ /* Llib/util.scm 110 */
if(
fexists(
BSTRING_TO_STRING(BGl_string1732z00zz__cryptozd2utilzd2)))
{ /* Llib/util.scm 126 */
 obj_t BgL_pz00_178;
{ /* Llib/util.scm 126 */

BgL_pz00_178 = 
BGl_openzd2inputzd2filez00zz__r4_ports_6_10_1z00(BGl_string1732z00zz__cryptozd2utilzd2, BTRUE, 
BINT(((long)5000000))); } 
if(
INPUT_PORTP(BgL_pz00_178))
{ /* Llib/util.scm 128 */
 obj_t BgL_exitd1021z00_180;
BgL_exitd1021z00_180 = 
BGL_EXITD_TOP_AS_OBJ(); 
{ /* Llib/util.scm 136 */
 obj_t BgL_zc3z04anonymousza31163ze3z87_982;
BgL_zc3z04anonymousza31163ze3z87_982 = 
MAKE_FX_PROCEDURE(BGl_z62zc3z04anonymousza31163ze3ze5zz__cryptozd2utilzd2, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3z04anonymousza31163ze3z87_982, 
(int)(((long)0)), BgL_pz00_178); 
{ /* Llib/util.scm 128 */
 obj_t BgL_arg1809z00_608;
{ /* Llib/util.scm 128 */
 obj_t BgL_arg1811z00_609;
BgL_arg1811z00_609 = 
BGL_EXITD_PROTECT(BgL_exitd1021z00_180); 
BgL_arg1809z00_608 = 
MAKE_YOUNG_PAIR(BgL_zc3z04anonymousza31163ze3z87_982, BgL_arg1811z00_609); } 
BGL_EXITD_PROTECT_SET(BgL_exitd1021z00_180, BgL_arg1809z00_608); BUNSPEC; } 
{ /* Llib/util.scm 129 */
 obj_t BgL_tmp1023z00_182;
{ /* Llib/util.scm 129 */
 obj_t BgL_strz00_183;
BgL_strz00_183 = 
BGl_readzd2charszd2zz__r4_input_6_10_2z00(
BINT(BgL_lenz00_19), BgL_pz00_178); 
{ /* Llib/util.scm 130 */
 bool_t BgL_test1864z00_1506;
if(
STRINGP(BgL_strz00_183))
{ /* Llib/util.scm 130 */
BgL_test1864z00_1506 = 
(BgL_lenz00_19==
STRING_LENGTH(BgL_strz00_183))
; }  else 
{ /* Llib/util.scm 130 */
BgL_test1864z00_1506 = ((bool_t)0)
; } 
if(BgL_test1864z00_1506)
{ /* Llib/util.scm 130 */
BgL_tmp1023z00_182 = BgL_strz00_183; }  else 
{ /* Llib/util.scm 130 */
{ /* Llib/util.scm 134 */
 obj_t BgL_list1160z00_187;
BgL_list1160z00_187 = 
MAKE_YOUNG_PAIR(BGl_string1733z00zz__cryptozd2utilzd2, BNIL); 
BGl_warningz00zz__errorz00(BgL_list1160z00_187); } 
BgL_tmp1023z00_182 = 
BGl_makezd2bglrandomzd2stringze70ze7zz__cryptozd2utilzd2(BgL_lenz00_19); } } } 
{ /* Llib/util.scm 128 */
 bool_t BgL_test1866z00_1514;
{ /* Llib/util.scm 128 */
 obj_t BgL_arg1808z00_614;
BgL_arg1808z00_614 = 
BGL_EXITD_PROTECT(BgL_exitd1021z00_180); 
BgL_test1866z00_1514 = 
PAIRP(BgL_arg1808z00_614); } 
if(BgL_test1866z00_1514)
{ /* Llib/util.scm 128 */
 obj_t BgL_arg1806z00_615;
{ /* Llib/util.scm 128 */
 obj_t BgL_arg1807z00_616;
BgL_arg1807z00_616 = 
BGL_EXITD_PROTECT(BgL_exitd1021z00_180); 
BgL_arg1806z00_615 = 
CDR(
((obj_t)BgL_arg1807z00_616)); } 
BGL_EXITD_PROTECT_SET(BgL_exitd1021z00_180, BgL_arg1806z00_615); BUNSPEC; }  else 
{ /* Llib/util.scm 128 */BFALSE; } } 
bgl_close_input_port(BgL_pz00_178); 
return BgL_tmp1023z00_182;} } }  else 
{ /* Llib/util.scm 127 */
return 
BGl_makezd2bglrandomzd2stringze70ze7zz__cryptozd2utilzd2(BgL_lenz00_19);} }  else 
{ /* Llib/util.scm 125 */
return 
BGl_makezd2bglrandomzd2stringze70ze7zz__cryptozd2utilzd2(BgL_lenz00_19);} } 

}



/* make-bglrandom-string~0 */
obj_t BGl_makezd2bglrandomzd2stringze70ze7zz__cryptozd2utilzd2(long BgL_lenz00_195)
{
{ /* Llib/util.scm 123 */
{ /* Llib/util.scm 116 */
 obj_t BgL_resz00_197;
{ /* Llib/util.scm 116 */

BgL_resz00_197 = 
make_string(BgL_lenz00_195, ((unsigned char)' ')); } 
{ 
 long BgL_iz00_199;
BgL_iz00_199 = ((long)0); 
BgL_zc3z04anonymousza31165ze3z87_200:
if(
(BgL_iz00_199>=BgL_lenz00_195))
{ /* Llib/util.scm 119 */
return BgL_resz00_197;}  else 
{ /* Llib/util.scm 119 */
{ /* Llib/util.scm 122 */
 unsigned char BgL_arg1167z00_202;
{ /* Llib/util.scm 122 */
 long BgL_arg1171z00_203;
{ /* Llib/util.scm 122 */
 int BgL_arg1347z00_600;
BgL_arg1347z00_600 = 
rand(); 
BgL_arg1171z00_203 = 
BGl_modulofxz00zz__r4_numbers_6_5_fixnumz00(
(long)(BgL_arg1347z00_600), ((long)256)); } 
BgL_arg1167z00_202 = 
(BgL_arg1171z00_203); } 
STRING_SET(BgL_resz00_197, BgL_iz00_199, BgL_arg1167z00_202); } 
{ 
 long BgL_iz00_1532;
BgL_iz00_1532 = 
(BgL_iz00_199+((long)1)); 
BgL_iz00_199 = BgL_iz00_1532; 
goto BgL_zc3z04anonymousza31165ze3z87_200;} } } } } 

}



/* &<@anonymous:1163> */
obj_t BGl_z62zc3z04anonymousza31163ze3ze5zz__cryptozd2utilzd2(obj_t BgL_envz00_983)
{
{ /* Llib/util.scm 128 */
{ /* Llib/util.scm 136 */
 obj_t BgL_pz00_984;
BgL_pz00_984 = 
PROCEDURE_REF(BgL_envz00_983, 
(int)(((long)0))); 
return 
bgl_close_input_port(
((obj_t)BgL_pz00_984));} } 

}



/* _make-random-bignum */
obj_t BGl__makezd2randomzd2bignumz00zz__cryptozd2utilzd2(obj_t BgL_env1052z00_26, obj_t BgL_opt1051z00_25)
{
{ /* Llib/util.scm 141 */
{ 
 obj_t BgL_k1z00_210; long BgL_iz00_211;
{ /* Llib/util.scm 141 */
 obj_t BgL_lenz00_213;
BgL_lenz00_213 = 
VECTOR_REF(BgL_opt1051z00_25,((long)0)); 
{ /* Llib/util.scm 141 */
 obj_t BgL_showzd2tracezd2_214;
BgL_showzd2tracezd2_214 = BFALSE; 
{ /* Llib/util.scm 141 */

{ 
 long BgL_iz00_215;
BgL_iz00_215 = ((long)1); 
BgL_check1055z00_216:
if(
(BgL_iz00_215==
VECTOR_LENGTH(BgL_opt1051z00_25)))
{ /* Llib/util.scm 141 */BNIL; }  else 
{ /* Llib/util.scm 141 */
 bool_t BgL_test1869z00_1542;
{ /* Llib/util.scm 141 */
 obj_t BgL_arg1180z00_222;
BgL_arg1180z00_222 = 
VECTOR_REF(BgL_opt1051z00_25,BgL_iz00_215); 
BgL_test1869z00_1542 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1180z00_222, 
CNST_TABLE_REF(((long)3)))); } 
if(BgL_test1869z00_1542)
{ 
 long BgL_iz00_1547;
BgL_iz00_1547 = 
(BgL_iz00_215+((long)2)); 
BgL_iz00_215 = BgL_iz00_1547; 
goto BgL_check1055z00_216;}  else 
{ /* Llib/util.scm 141 */
 obj_t BgL_arg1179z00_221;
BgL_arg1179z00_221 = 
VECTOR_REF(BgL_opt1051z00_25,BgL_iz00_215); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string1730z00zz__cryptozd2utilzd2, BgL_arg1179z00_221); } } } 
{ /* Llib/util.scm 141 */
 obj_t BgL_index1057z00_223;
BgL_k1z00_210 = 
CNST_TABLE_REF(((long)4)); 
BgL_iz00_211 = ((long)1); 
BgL_search1054z00_212:
if(
(BgL_iz00_211==
VECTOR_LENGTH(BgL_opt1051z00_25)))
{ /* Llib/util.scm 141 */
BgL_index1057z00_223 = 
BINT(((long)-1)); }  else 
{ /* Llib/util.scm 141 */
if(
(BgL_iz00_211==
(
VECTOR_LENGTH(BgL_opt1051z00_25)-((long)1))))
{ /* Llib/util.scm 141 */
BgL_index1057z00_223 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string1729z00zz__cryptozd2utilzd2, 
BINT(
VECTOR_LENGTH(BgL_opt1051z00_25))); }  else 
{ /* Llib/util.scm 141 */
 obj_t BgL_vz00_231;
BgL_vz00_231 = 
VECTOR_REF(BgL_opt1051z00_25,BgL_iz00_211); 
if(
(BgL_vz00_231==BgL_k1z00_210))
{ /* Llib/util.scm 141 */
BgL_index1057z00_223 = 
BINT(
(BgL_iz00_211+((long)1))); }  else 
{ 
 long BgL_iz00_1569;
BgL_iz00_1569 = 
(BgL_iz00_211+((long)2)); 
BgL_iz00_211 = BgL_iz00_1569; 
goto BgL_search1054z00_212;} } } 
{ /* Llib/util.scm 141 */
 bool_t BgL_test1873z00_1572;
{ /* Llib/util.scm 141 */
 long BgL_n1z00_634;
{ /* Llib/util.scm 141 */
 obj_t BgL_tmpz00_1573;
if(
INTEGERP(BgL_index1057z00_223))
{ /* Llib/util.scm 141 */
BgL_tmpz00_1573 = BgL_index1057z00_223
; }  else 
{ 
 obj_t BgL_auxz00_1576;
BgL_auxz00_1576 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)4434)), BGl_string1734z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_index1057z00_223); 
FAILURE(BgL_auxz00_1576,BFALSE,BFALSE);} 
BgL_n1z00_634 = 
(long)CINT(BgL_tmpz00_1573); } 
BgL_test1873z00_1572 = 
(BgL_n1z00_634>=((long)0)); } 
if(BgL_test1873z00_1572)
{ 
 long BgL_auxz00_1582;
{ /* Llib/util.scm 141 */
 obj_t BgL_tmpz00_1583;
if(
INTEGERP(BgL_index1057z00_223))
{ /* Llib/util.scm 141 */
BgL_tmpz00_1583 = BgL_index1057z00_223
; }  else 
{ 
 obj_t BgL_auxz00_1586;
BgL_auxz00_1586 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)4434)), BGl_string1734z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_index1057z00_223); 
FAILURE(BgL_auxz00_1586,BFALSE,BFALSE);} 
BgL_auxz00_1582 = 
(long)CINT(BgL_tmpz00_1583); } 
BgL_showzd2tracezd2_214 = 
VECTOR_REF(BgL_opt1051z00_25,BgL_auxz00_1582); }  else 
{ /* Llib/util.scm 141 */BFALSE; } } } 
{ /* Llib/util.scm 141 */
 obj_t BgL_arg1182z00_225;
BgL_arg1182z00_225 = 
VECTOR_REF(BgL_opt1051z00_25,((long)0)); 
{ /* Llib/util.scm 141 */
 obj_t BgL_showzd2tracezd2_226;
BgL_showzd2tracezd2_226 = BgL_showzd2tracezd2_214; 
{ /* Llib/util.scm 141 */
 long BgL_auxz00_1593;
{ /* Llib/util.scm 141 */
 obj_t BgL_tmpz00_1594;
if(
INTEGERP(BgL_arg1182z00_225))
{ /* Llib/util.scm 141 */
BgL_tmpz00_1594 = BgL_arg1182z00_225
; }  else 
{ 
 obj_t BgL_auxz00_1597;
BgL_auxz00_1597 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)4434)), BGl_string1734z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_arg1182z00_225); 
FAILURE(BgL_auxz00_1597,BFALSE,BFALSE);} 
BgL_auxz00_1593 = 
(long)CINT(BgL_tmpz00_1594); } 
return 
BGl_makezd2randomzd2bignumz00zz__cryptozd2utilzd2(BgL_auxz00_1593, BgL_showzd2tracezd2_226);} } } } } } } } 

}



/* make-random-bignum */
BGL_EXPORTED_DEF obj_t BGl_makezd2randomzd2bignumz00zz__cryptozd2utilzd2(long BgL_lenz00_23, obj_t BgL_showzd2tracezd2_24)
{
{ /* Llib/util.scm 141 */
if(
(BgL_lenz00_23==((long)0)))
{ /* Llib/util.scm 142 */
return 
CNST_TABLE_REF(((long)1));}  else 
{ /* Llib/util.scm 144 */
 long BgL_strzd2lenzd2_236;
BgL_strzd2lenzd2_236 = 
(
(BgL_lenz00_23+((long)7))/((long)8)); 
{ /* Llib/util.scm 144 */
 obj_t BgL_strz00_237;
BgL_strz00_237 = 
BGl_makezd2randomzd2stringz00zz__cryptozd2utilzd2(BgL_strzd2lenzd2_236, BFALSE); 
{ /* Llib/util.scm 145 */
 obj_t BgL_lastzd2bitszd2_238;
BgL_lastzd2bitszd2_238 = 
BGl_remainderz00zz__r4_numbers_6_5_fixnumz00(
BINT(BgL_lenz00_23), 
BINT(((long)8))); 
{ /* Llib/util.scm 146 */
 obj_t BgL_maskz00_239;
if(
INTEGERP(BgL_lastzd2bitszd2_238))
{ /* Llib/util.scm 147 */
switch( 
(long)CINT(BgL_lastzd2bitszd2_238)) { case ((long)0) : 

BgL_maskz00_239 = 
BINT(((long)255)); break;case ((long)7) : 

BgL_maskz00_239 = 
BINT(((long)127)); break;case ((long)6) : 

BgL_maskz00_239 = 
BINT(((long)63)); break;case ((long)5) : 

BgL_maskz00_239 = 
BINT(((long)31)); break;case ((long)4) : 

BgL_maskz00_239 = 
BINT(((long)15)); break;case ((long)3) : 

BgL_maskz00_239 = 
BINT(((long)7)); break;case ((long)2) : 

BgL_maskz00_239 = 
BINT(((long)3)); break;case ((long)1) : 

BgL_maskz00_239 = 
BINT(((long)1)); break;
default: 
BgL_maskz00_239 = BUNSPEC; } }  else 
{ /* Llib/util.scm 147 */
BgL_maskz00_239 = BUNSPEC; } 
{ /* Llib/util.scm 147 */
 unsigned char BgL_firstzd2charzd2_240;
BgL_firstzd2charzd2_240 = 
STRING_REF(
((obj_t)BgL_strz00_237), ((long)0)); 
{ /* Llib/util.scm 151 */
 long BgL_firstzd2charzd2nz00_241;
BgL_firstzd2charzd2nz00_241 = 
(BgL_firstzd2charzd2_240); 
{ /* Llib/util.scm 152 */
 unsigned char BgL_maskedz00_242;
BgL_maskedz00_242 = 
(
(
(long)CINT(BgL_maskz00_239) & BgL_firstzd2charzd2nz00_241)); 
{ /* Llib/util.scm 153 */

{ /* Llib/util.scm 154 */
 obj_t BgL_tmpz00_1630;
BgL_tmpz00_1630 = 
((obj_t)BgL_strz00_237); 
STRING_SET(BgL_tmpz00_1630, ((long)0), BgL_maskedz00_242); } 
{ 
 long BgL_iz00_659; obj_t BgL_resz00_660;
BgL_iz00_659 = ((long)0); 
BgL_resz00_660 = 
CNST_TABLE_REF(((long)1)); 
BgL_loopz00_658:
if(
(BgL_iz00_659>=BgL_strzd2lenzd2_236))
{ /* Llib/util.scm 157 */
return BgL_resz00_660;}  else 
{ 
 obj_t BgL_resz00_1637; long BgL_iz00_1635;
BgL_iz00_1635 = 
(BgL_iz00_659+((long)1)); 
BgL_resz00_1637 = 
bgl_bignum_add(
bgl_bignum_mul(
CNST_TABLE_REF(((long)0)), BgL_resz00_660), 
bgl_long_to_bignum(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_strz00_237), BgL_iz00_659)))))); 
BgL_resz00_660 = BgL_resz00_1637; 
BgL_iz00_659 = BgL_iz00_1635; 
goto BgL_loopz00_658;} } } } } } } } } } } 

}



/* char-xor */
BGL_EXPORTED_DEF unsigned char BGl_charzd2xorzd2zz__cryptozd2utilzd2(unsigned char BgL_c1z00_27, unsigned char BgL_c2z00_28)
{
{ /* Llib/util.scm 163 */
return 
(char)(
(
(
(
(unsigned char)(BgL_c1z00_27)) ^ 
(
(unsigned char)(BgL_c2z00_28)))));} 

}



/* &char-xor */
obj_t BGl_z62charzd2xorzb0zz__cryptozd2utilzd2(obj_t BgL_envz00_985, obj_t BgL_c1z00_986, obj_t BgL_c2z00_987)
{
{ /* Llib/util.scm 163 */
{ /* Llib/util.scm 164 */
 unsigned char BgL_tmpz00_1655;
{ /* Llib/util.scm 164 */
 unsigned char BgL_auxz00_1665; unsigned char BgL_auxz00_1656;
{ /* Llib/util.scm 164 */
 obj_t BgL_tmpz00_1666;
if(
CHARP(BgL_c2z00_987))
{ /* Llib/util.scm 164 */
BgL_tmpz00_1666 = BgL_c2z00_987
; }  else 
{ 
 obj_t BgL_auxz00_1669;
BgL_auxz00_1669 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)5226)), BGl_string1735z00zz__cryptozd2utilzd2, BGl_string1722z00zz__cryptozd2utilzd2, BgL_c2z00_987); 
FAILURE(BgL_auxz00_1669,BFALSE,BFALSE);} 
BgL_auxz00_1665 = 
CCHAR(BgL_tmpz00_1666); } 
{ /* Llib/util.scm 164 */
 obj_t BgL_tmpz00_1657;
if(
CHARP(BgL_c1z00_986))
{ /* Llib/util.scm 164 */
BgL_tmpz00_1657 = BgL_c1z00_986
; }  else 
{ 
 obj_t BgL_auxz00_1660;
BgL_auxz00_1660 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)5226)), BGl_string1735z00zz__cryptozd2utilzd2, BGl_string1722z00zz__cryptozd2utilzd2, BgL_c1z00_986); 
FAILURE(BgL_auxz00_1660,BFALSE,BFALSE);} 
BgL_auxz00_1656 = 
CCHAR(BgL_tmpz00_1657); } 
BgL_tmpz00_1655 = 
BGl_charzd2xorzd2zz__cryptozd2utilzd2(BgL_auxz00_1656, BgL_auxz00_1665); } 
return 
BCHAR(BgL_tmpz00_1655);} } 

}



/* string-xor */
BGL_EXPORTED_DEF obj_t BGl_stringzd2xorzd2zz__cryptozd2utilzd2(obj_t BgL_str1z00_29, obj_t BgL_str2z00_30)
{
{ /* Llib/util.scm 166 */
{ /* Llib/util.scm 167 */
 long BgL_lenz00_263;
BgL_lenz00_263 = 
STRING_LENGTH(BgL_str1z00_29); 
if(
(BgL_lenz00_263==
STRING_LENGTH(BgL_str2z00_30)))
{ /* Llib/util.scm 168 */BFALSE; }  else 
{ /* Llib/util.scm 168 */
BGl_errorz00zz__errorz00(BGl_string1736z00zz__cryptozd2utilzd2, BGl_string1737z00zz__cryptozd2utilzd2, BgL_str2z00_30); } 
{ /* Llib/util.scm 170 */
 obj_t BgL_resz00_267;
{ /* Llib/util.scm 170 */

BgL_resz00_267 = 
make_string(BgL_lenz00_263, ((unsigned char)' ')); } 
{ 
 long BgL_iz00_269;
BgL_iz00_269 = ((long)0); 
BgL_zc3z04anonymousza31219ze3z87_270:
if(
(BgL_iz00_269>=BgL_lenz00_263))
{ /* Llib/util.scm 173 */
return BgL_resz00_267;}  else 
{ /* Llib/util.scm 173 */
{ /* Llib/util.scm 176 */
 unsigned char BgL_arg1221z00_272;
BgL_arg1221z00_272 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(BgL_str1z00_29, BgL_iz00_269)))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(BgL_str2z00_30, BgL_iz00_269))))))); 
{ /* Llib/util.scm 176 */
 unsigned char BgL_tmpz00_1695;
BgL_tmpz00_1695 = 
(unsigned char)(BgL_arg1221z00_272); 
STRING_SET(BgL_resz00_267, BgL_iz00_269, BgL_tmpz00_1695); } } 
{ 
 long BgL_iz00_1698;
BgL_iz00_1698 = 
(BgL_iz00_269+((long)1)); 
BgL_iz00_269 = BgL_iz00_1698; 
goto BgL_zc3z04anonymousza31219ze3z87_270;} } } } } } 

}



/* &string-xor */
obj_t BGl_z62stringzd2xorzb0zz__cryptozd2utilzd2(obj_t BgL_envz00_988, obj_t BgL_str1z00_989, obj_t BgL_str2z00_990)
{
{ /* Llib/util.scm 166 */
{ /* Llib/util.scm 167 */
 obj_t BgL_auxz00_1707; obj_t BgL_auxz00_1700;
if(
STRINGP(BgL_str2z00_990))
{ /* Llib/util.scm 167 */
BgL_auxz00_1707 = BgL_str2z00_990
; }  else 
{ 
 obj_t BgL_auxz00_1710;
BgL_auxz00_1710 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)5329)), BGl_string1738z00zz__cryptozd2utilzd2, BGl_string1724z00zz__cryptozd2utilzd2, BgL_str2z00_990); 
FAILURE(BgL_auxz00_1710,BFALSE,BFALSE);} 
if(
STRINGP(BgL_str1z00_989))
{ /* Llib/util.scm 167 */
BgL_auxz00_1700 = BgL_str1z00_989
; }  else 
{ 
 obj_t BgL_auxz00_1703;
BgL_auxz00_1703 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)5329)), BGl_string1738z00zz__cryptozd2utilzd2, BGl_string1724z00zz__cryptozd2utilzd2, BgL_str1z00_989); 
FAILURE(BgL_auxz00_1703,BFALSE,BFALSE);} 
return 
BGl_stringzd2xorzd2zz__cryptozd2utilzd2(BgL_auxz00_1700, BgL_auxz00_1707);} } 

}



/* string-xor! */
BGL_EXPORTED_DEF obj_t BGl_stringzd2xorz12zc0zz__cryptozd2utilzd2(obj_t BgL_str1z00_31, obj_t BgL_str2z00_32, obj_t BgL_lenz00_33)
{
{ /* Llib/util.scm 181 */
{ 
 long BgL_iz00_1108;
BgL_iz00_1108 = ((long)0); 
BgL_loopz00_1107:
if(
(BgL_iz00_1108==
(long)CINT(BgL_lenz00_33)))
{ /* Llib/util.scm 186 */
return BgL_str1z00_31;}  else 
{ /* Llib/util.scm 186 */
{ /* Llib/util.scm 189 */
 long BgL_arg1229z00_1109; unsigned char BgL_arg1230z00_1110;
BgL_arg1229z00_1109 = 
(((long)0)+BgL_iz00_1108); 
BgL_arg1230z00_1110 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_str1z00_31), 
(((long)0)+BgL_iz00_1108))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_str2z00_32), 
(((long)0)+BgL_iz00_1108)))))))); 
{ /* Llib/util.scm 189 */
 unsigned char BgL_charz00_1111;
BgL_charz00_1111 = 
(unsigned char)(BgL_arg1230z00_1110); 
{ /* Llib/util.scm 189 */
 obj_t BgL_tmpz00_1735;
BgL_tmpz00_1735 = 
((obj_t)BgL_str1z00_31); 
STRING_SET(BgL_tmpz00_1735, BgL_arg1229z00_1109, BgL_charz00_1111); } } } 
{ 
 long BgL_iz00_1738;
BgL_iz00_1738 = 
(BgL_iz00_1108+((long)1)); 
BgL_iz00_1108 = BgL_iz00_1738; 
goto BgL_loopz00_1107;} } } } 

}



/* &string-xor! */
obj_t BGl_z62stringzd2xorz12za2zz__cryptozd2utilzd2(obj_t BgL_envz00_991, obj_t BgL_str1z00_992, obj_t BgL_str2z00_993, obj_t BgL_lenz00_994)
{
{ /* Llib/util.scm 181 */
return 
BGl_stringzd2xorz12zc0zz__cryptozd2utilzd2(BgL_str1z00_992, BgL_str2z00_993, BgL_lenz00_994);} 

}



/* string-xor-buffer! */
BGL_EXPORTED_DEF obj_t BGl_stringzd2xorzd2bufferz12z12zz__cryptozd2utilzd2(obj_t BgL_targetz00_34, obj_t BgL_targetzd2poszd2_35, obj_t BgL_str1z00_36, obj_t BgL_str1zd2poszd2_37, obj_t BgL_str2z00_38, obj_t BgL_str2zd2poszd2_39, obj_t BgL_lenz00_40)
{
{ /* Llib/util.scm 183 */
{ 
 long BgL_iz00_1113;
BgL_iz00_1113 = ((long)0); 
BgL_loopz00_1112:
if(
(BgL_iz00_1113==
(long)CINT(BgL_lenz00_40)))
{ /* Llib/util.scm 186 */
return BgL_targetz00_34;}  else 
{ /* Llib/util.scm 186 */
{ /* Llib/util.scm 189 */
 long BgL_arg1229z00_1114; unsigned char BgL_arg1230z00_1115;
BgL_arg1229z00_1114 = 
(
(long)CINT(BgL_targetzd2poszd2_35)+BgL_iz00_1113); 
BgL_arg1230z00_1115 = 
(char)(
(
(
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_str1z00_36), 
(
(long)CINT(BgL_str1zd2poszd2_37)+BgL_iz00_1113))))) ^ 
(
(unsigned char)(
(char)(
STRING_REF(
((obj_t)BgL_str2z00_38), 
(
(long)CINT(BgL_str2zd2poszd2_39)+BgL_iz00_1113)))))))); 
{ /* Llib/util.scm 189 */
 unsigned char BgL_charz00_1116;
BgL_charz00_1116 = 
(unsigned char)(BgL_arg1230z00_1115); 
{ /* Llib/util.scm 189 */
 obj_t BgL_tmpz00_1764;
BgL_tmpz00_1764 = 
((obj_t)BgL_targetz00_34); 
STRING_SET(BgL_tmpz00_1764, BgL_arg1229z00_1114, BgL_charz00_1116); } } } 
{ 
 long BgL_iz00_1767;
BgL_iz00_1767 = 
(BgL_iz00_1113+((long)1)); 
BgL_iz00_1113 = BgL_iz00_1767; 
goto BgL_loopz00_1112;} } } } 

}



/* &string-xor-buffer! */
obj_t BGl_z62stringzd2xorzd2bufferz12z70zz__cryptozd2utilzd2(obj_t BgL_envz00_995, obj_t BgL_targetz00_996, obj_t BgL_targetzd2poszd2_997, obj_t BgL_str1z00_998, obj_t BgL_str1zd2poszd2_999, obj_t BgL_str2z00_1000, obj_t BgL_str2zd2poszd2_1001, obj_t BgL_lenz00_1002)
{
{ /* Llib/util.scm 183 */
return 
BGl_stringzd2xorzd2bufferz12z12zz__cryptozd2utilzd2(BgL_targetz00_996, BgL_targetzd2poszd2_997, BgL_str1z00_998, BgL_str1zd2poszd2_999, BgL_str2z00_1000, BgL_str2zd2poszd2_1001, BgL_lenz00_1002);} 

}



/* read-armored-base64-data */
BGL_EXPORTED_DEF obj_t BGl_readzd2armoredzd2base64zd2datazd2zz__cryptozd2utilzd2(obj_t BgL_pz00_41)
{
{ /* Llib/util.scm 194 */
{ /* Llib/util.scm 195 */
 obj_t BgL_dataz00_291;
{ 
 obj_t BgL_strz00_295;
BgL_strz00_295 = BGl_string1740z00zz__cryptozd2utilzd2; 
BgL_zc3z04anonymousza31240ze3z87_296:
{ /* Llib/util.scm 196 */
 obj_t BgL_lz00_297;
BgL_lz00_297 = 
BGl_readzd2linezd2zz__r4_input_6_10_2z00(BgL_pz00_41); 
if(
EOF_OBJECTP(BgL_lz00_297))
{ /* Llib/util.scm 198 */
BgL_dataz00_291 = BgL_strz00_295; }  else 
{ /* Llib/util.scm 199 */
 bool_t BgL_test1889z00_1773;
{ /* Llib/util.scm 199 */

BgL_test1889z00_1773 = 
BGl_stringzd2prefixzf3z21zz__r4_strings_6_7z00(BGl_string1739z00zz__cryptozd2utilzd2, BgL_lz00_297, BFALSE, BFALSE, BFALSE, BFALSE); } 
if(BgL_test1889z00_1773)
{ /* Llib/util.scm 199 */
BgL_dataz00_291 = BgL_strz00_295; }  else 
{ 
 obj_t BgL_strz00_1775;
BgL_strz00_1775 = 
string_append(BgL_strz00_295, BgL_lz00_297); 
BgL_strz00_295 = BgL_strz00_1775; 
goto BgL_zc3z04anonymousza31240ze3z87_296;} } } } 
{ /* Llib/util.scm 201 */

return 
BGl_base64zd2decodezd2zz__base64z00(BgL_dataz00_291, BFALSE);} } } 

}



/* &read-armored-base64-data */
obj_t BGl_z62readzd2armoredzd2base64zd2datazb0zz__cryptozd2utilzd2(obj_t BgL_envz00_1003, obj_t BgL_pz00_1004)
{
{ /* Llib/util.scm 194 */
return 
BGl_readzd2armoredzd2base64zd2datazd2zz__cryptozd2utilzd2(BgL_pz00_1004);} 

}



/* str->hex-string */
BGL_EXPORTED_DEF obj_t BGl_strzd2ze3hexzd2stringze3zz__cryptozd2utilzd2(obj_t BgL_strz00_42)
{
{ /* Llib/util.scm 203 */
{ /* Llib/util.scm 204 */
 long BgL_endz00_1117;
BgL_endz00_1117 = 
STRING_LENGTH(BgL_strz00_42); 
{ /* Llib/util.scm 204 */

return 
BGl_stringzd2hexzd2externz00zz__r4_strings_6_7z00(BgL_strz00_42, 
(int)(((long)0)), BgL_endz00_1117);} } } 

}



/* &str->hex-string */
obj_t BGl_z62strzd2ze3hexzd2stringz81zz__cryptozd2utilzd2(obj_t BgL_envz00_1005, obj_t BgL_strz00_1006)
{
{ /* Llib/util.scm 203 */
{ /* Llib/util.scm 204 */
 obj_t BgL_auxz00_1782;
if(
STRINGP(BgL_strz00_1006))
{ /* Llib/util.scm 204 */
BgL_auxz00_1782 = BgL_strz00_1006
; }  else 
{ 
 obj_t BgL_auxz00_1785;
BgL_auxz00_1785 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)6455)), BGl_string1741z00zz__cryptozd2utilzd2, BGl_string1724z00zz__cryptozd2utilzd2, BgL_strz00_1006); 
FAILURE(BgL_auxz00_1785,BFALSE,BFALSE);} 
return 
BGl_strzd2ze3hexzd2stringze3zz__cryptozd2utilzd2(BgL_auxz00_1782);} } 

}



/* hex-str->string */
BGL_EXPORTED_DEF obj_t BGl_hexzd2strzd2ze3stringze3zz__cryptozd2utilzd2(obj_t BgL_hexzd2strzd2_43)
{
{ /* Llib/util.scm 206 */
return 
BGl_stringzd2hexzd2internz00zz__r4_strings_6_7z00(BgL_hexzd2strzd2_43);} 

}



/* &hex-str->string */
obj_t BGl_z62hexzd2strzd2ze3stringz81zz__cryptozd2utilzd2(obj_t BgL_envz00_1007, obj_t BgL_hexzd2strzd2_1008)
{
{ /* Llib/util.scm 206 */
{ /* Llib/util.scm 207 */
 obj_t BgL_auxz00_1791;
if(
STRINGP(BgL_hexzd2strzd2_1008))
{ /* Llib/util.scm 207 */
BgL_auxz00_1791 = BgL_hexzd2strzd2_1008
; }  else 
{ 
 obj_t BgL_auxz00_1794;
BgL_auxz00_1794 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)6524)), BGl_string1742z00zz__cryptozd2utilzd2, BGl_string1724z00zz__cryptozd2utilzd2, BgL_hexzd2strzd2_1008); 
FAILURE(BgL_auxz00_1794,BFALSE,BFALSE);} 
return 
BGl_hexzd2strzd2ze3stringze3zz__cryptozd2utilzd2(BgL_auxz00_1791);} } 

}



/* hex-str->string! */
BGL_EXPORTED_DEF obj_t BGl_hexzd2strzd2ze3stringz12zf1zz__cryptozd2utilzd2(obj_t BgL_hexzd2strzd2_44)
{
{ /* Llib/util.scm 208 */
return 
BGl_stringzd2hexzd2internz12z12zz__r4_strings_6_7z00(BgL_hexzd2strzd2_44);} 

}



/* &hex-str->string! */
obj_t BGl_z62hexzd2strzd2ze3stringz12z93zz__cryptozd2utilzd2(obj_t BgL_envz00_1009, obj_t BgL_hexzd2strzd2_1010)
{
{ /* Llib/util.scm 208 */
{ /* Llib/util.scm 209 */
 obj_t BgL_auxz00_1800;
if(
STRINGP(BgL_hexzd2strzd2_1010))
{ /* Llib/util.scm 209 */
BgL_auxz00_1800 = BgL_hexzd2strzd2_1010
; }  else 
{ 
 obj_t BgL_auxz00_1803;
BgL_auxz00_1803 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)6616)), BGl_string1743z00zz__cryptozd2utilzd2, BGl_string1724z00zz__cryptozd2utilzd2, BgL_hexzd2strzd2_1010); 
FAILURE(BgL_auxz00_1803,BFALSE,BFALSE);} 
return 
BGl_hexzd2strzd2ze3stringz12zf1zz__cryptozd2utilzd2(BgL_auxz00_1800);} } 

}



/* gcd-ext */
obj_t BGl_gcdzd2extzd2zz__cryptozd2utilzd2(obj_t BgL_xz00_45, obj_t BgL_yz00_46)
{
{ /* Llib/util.scm 211 */
{ 
 obj_t BgL_xz00_838; obj_t BgL_yz00_839; obj_t BgL_u1z00_840; obj_t BgL_u2z00_841; obj_t BgL_v1z00_842; obj_t BgL_v2z00_843;
BgL_xz00_838 = BgL_xz00_45; 
BgL_yz00_839 = BgL_yz00_46; 
BgL_u1z00_840 = 
CNST_TABLE_REF(((long)6)); 
BgL_u2z00_841 = 
CNST_TABLE_REF(((long)1)); 
BgL_v1z00_842 = 
CNST_TABLE_REF(((long)1)); 
BgL_v2z00_843 = 
CNST_TABLE_REF(((long)6)); 
BgL_loopz00_837:
{ /* Llib/util.scm 218 */
 bool_t BgL_test1893z00_1808;
{ /* Llib/util.scm 218 */
 obj_t BgL_tmpz00_1809;
BgL_tmpz00_1809 = 
((obj_t)BgL_yz00_839); 
BgL_test1893z00_1808 = 
BXZERO(BgL_tmpz00_1809); } 
if(BgL_test1893z00_1808)
{ /* Llib/util.scm 219 */
 obj_t BgL_list1255z00_855;
{ /* Llib/util.scm 219 */
 obj_t BgL_arg1262z00_856;
{ /* Llib/util.scm 219 */
 obj_t BgL_arg1263z00_857;
BgL_arg1263z00_857 = 
MAKE_YOUNG_PAIR(BgL_v1z00_842, BNIL); 
BgL_arg1262z00_856 = 
MAKE_YOUNG_PAIR(BgL_u1z00_840, BgL_arg1263z00_857); } 
BgL_list1255z00_855 = 
MAKE_YOUNG_PAIR(BgL_xz00_838, BgL_arg1262z00_856); } 
return BgL_list1255z00_855;}  else 
{ /* Llib/util.scm 220 */
 obj_t BgL_qz00_858; obj_t BgL_rz00_859;
BgL_qz00_858 = 
bgl_bignum_quotient(
((obj_t)BgL_xz00_838), 
((obj_t)BgL_yz00_839)); 
BgL_rz00_859 = 
bgl_bignum_remainder(
((obj_t)BgL_xz00_838), 
((obj_t)BgL_yz00_839)); 
{ 
 obj_t BgL_v2z00_1828; obj_t BgL_v1z00_1827; obj_t BgL_u2z00_1824; obj_t BgL_u1z00_1823; obj_t BgL_yz00_1822; obj_t BgL_xz00_1821;
BgL_xz00_1821 = BgL_yz00_839; 
BgL_yz00_1822 = BgL_rz00_859; 
BgL_u1z00_1823 = BgL_u2z00_841; 
BgL_u2z00_1824 = 
bgl_bignum_sub(BgL_u1z00_840, 
bgl_bignum_mul(BgL_qz00_858, BgL_u2z00_841)); 
BgL_v1z00_1827 = BgL_v2z00_843; 
BgL_v2z00_1828 = 
bgl_bignum_sub(BgL_v1z00_842, 
bgl_bignum_mul(BgL_qz00_858, BgL_v2z00_843)); 
BgL_v2z00_843 = BgL_v2z00_1828; 
BgL_v1z00_842 = BgL_v1z00_1827; 
BgL_u2z00_841 = BgL_u2z00_1824; 
BgL_u1z00_840 = BgL_u1z00_1823; 
BgL_yz00_839 = BgL_yz00_1822; 
BgL_xz00_838 = BgL_xz00_1821; 
goto BgL_loopz00_837;} } } } } 

}



/* mod-inverse */
BGL_EXPORTED_DEF obj_t BGl_modzd2inversezd2zz__cryptozd2utilzd2(obj_t BgL_xz00_47, obj_t BgL_bz00_48)
{
{ /* Llib/util.scm 224 */
{ /* Llib/util.scm 225 */
 obj_t BgL_x1z00_336;
BgL_x1z00_336 = 
BGl_modulobxz00zz__r4_numbers_6_5_fixnumz00(BgL_xz00_47, BgL_bz00_48); 
{ /* Llib/util.scm 225 */
 obj_t BgL_gz00_337;
BgL_gz00_337 = 
BGl_gcdzd2extzd2zz__cryptozd2utilzd2(BgL_x1z00_336, BgL_bz00_48); 
{ /* Llib/util.scm 226 */

{ /* Llib/util.scm 227 */
 bool_t BgL_test1894z00_1837;
{ /* Llib/util.scm 227 */
 obj_t BgL_n1z00_879;
BgL_n1z00_879 = 
CAR(
((obj_t)BgL_gz00_337)); 
BgL_test1894z00_1837 = 
(
(long)(
bgl_bignum_cmp(BgL_n1z00_879, 
CNST_TABLE_REF(((long)6))))==((long)0)); } 
if(BgL_test1894z00_1837)
{ /* Llib/util.scm 231 */
 obj_t BgL_auxz00_1844;
{ /* Llib/util.scm 231 */
 obj_t BgL_pairz00_886;
BgL_pairz00_886 = 
CDR(
((obj_t)BgL_gz00_337)); 
BgL_auxz00_1844 = 
CAR(BgL_pairz00_886); } 
return 
BGl_modulobxz00zz__r4_numbers_6_5_fixnumz00(BgL_auxz00_1844, BgL_bz00_48);}  else 
{ /* Llib/util.scm 230 */
 obj_t BgL_arg1283z00_341;
BgL_arg1283z00_341 = 
MAKE_YOUNG_PAIR(BgL_xz00_47, BgL_bz00_48); 
return 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)7)), BGl_string1744z00zz__cryptozd2utilzd2, BgL_arg1283z00_341);} } } } } } 

}



/* &mod-inverse */
obj_t BGl_z62modzd2inversezb0zz__cryptozd2utilzd2(obj_t BgL_envz00_1011, obj_t BgL_xz00_1012, obj_t BgL_bz00_1013)
{
{ /* Llib/util.scm 224 */
return 
BGl_modzd2inversezd2zz__cryptozd2utilzd2(BgL_xz00_1012, BgL_bz00_1013);} 

}



/* expt-modbx */
BGL_EXPORTED_DEF obj_t BGl_exptzd2modbxzd2zz__cryptozd2utilzd2(obj_t BgL_xz00_49, obj_t BgL_yz00_50, obj_t BgL_mz00_51)
{
{ /* Llib/util.scm 233 */
return 
BGl_exptzd2modze70z35zz__cryptozd2utilzd2(BgL_xz00_49, BgL_yz00_50, BgL_mz00_51);} 

}



/* expt-mod~0 */
obj_t BGl_exptzd2modze70z35zz__cryptozd2utilzd2(obj_t BgL_nz00_344, obj_t BgL_ez00_345, obj_t BgL_mz00_346)
{
{ /* Llib/util.scm 242 */
BGl_exptzd2modze70z35zz__cryptozd2utilzd2:
{ /* Llib/util.scm 237 */
 bool_t BgL_test1895z00_1854;
{ /* Llib/util.scm 237 */
 obj_t BgL_tmpz00_1855;
BgL_tmpz00_1855 = 
((obj_t)BgL_ez00_345); 
BgL_test1895z00_1854 = 
BXZERO(BgL_tmpz00_1855); } 
if(BgL_test1895z00_1854)
{ /* Llib/util.scm 237 */
return 
CNST_TABLE_REF(((long)6));}  else 
{ /* Llib/util.scm 237 */
if(
bgl_bignum_even(
((obj_t)BgL_ez00_345)))
{ 
 obj_t BgL_ez00_1867; obj_t BgL_nz00_1862;
BgL_nz00_1862 = 
BGl_modulobxz00zz__r4_numbers_6_5_fixnumz00(
bgl_bignum_mul(
((obj_t)BgL_nz00_344), 
((obj_t)BgL_nz00_344)), BgL_mz00_346); 
BgL_ez00_1867 = 
bgl_bignum_quotient(
((obj_t)BgL_ez00_345), 
CNST_TABLE_REF(((long)8))); 
BgL_ez00_345 = BgL_ez00_1867; 
BgL_nz00_344 = BgL_nz00_1862; 
goto BGl_exptzd2modze70z35zz__cryptozd2utilzd2;}  else 
{ /* Llib/util.scm 239 */
return 
BGl_modulobxz00zz__r4_numbers_6_5_fixnumz00(
bgl_bignum_mul(
((obj_t)BgL_nz00_344), 
BGl_exptzd2modze70z35zz__cryptozd2utilzd2(BgL_nz00_344, 
bgl_bignum_sub(
((obj_t)BgL_ez00_345), 
CNST_TABLE_REF(((long)6))), BgL_mz00_346)), BgL_mz00_346);} } } } 

}



/* &expt-modbx */
obj_t BGl_z62exptzd2modbxzb0zz__cryptozd2utilzd2(obj_t BgL_envz00_1014, obj_t BgL_xz00_1015, obj_t BgL_yz00_1016, obj_t BgL_mz00_1017)
{
{ /* Llib/util.scm 233 */
return 
BGl_exptzd2modbxzd2zz__cryptozd2utilzd2(BgL_xz00_1015, BgL_yz00_1016, BgL_mz00_1017);} 

}



/* sha1sum-bin */
BGL_EXPORTED_DEF obj_t BGl_sha1sumzd2binzd2zz__cryptozd2utilzd2(obj_t BgL_inz00_52)
{
{ /* Llib/util.scm 246 */
return 
BGl_stringzd2hexzd2internz12z12zz__r4_strings_6_7z00(
BGl_sha1sumz00zz__sha1z00(BgL_inz00_52));} 

}



/* &sha1sum-bin */
obj_t BGl_z62sha1sumzd2binzb0zz__cryptozd2utilzd2(obj_t BgL_envz00_1018, obj_t BgL_inz00_1019)
{
{ /* Llib/util.scm 246 */
return 
BGl_sha1sumzd2binzd2zz__cryptozd2utilzd2(BgL_inz00_1019);} 

}



/* sha256sum-bin */
BGL_EXPORTED_DEF obj_t BGl_sha256sumzd2binzd2zz__cryptozd2utilzd2(obj_t BgL_inz00_53)
{
{ /* Llib/util.scm 249 */
return 
BGl_stringzd2hexzd2internz12z12zz__r4_strings_6_7z00(
BGl_sha256sumz00zz__sha2z00(BgL_inz00_53));} 

}



/* &sha256sum-bin */
obj_t BGl_z62sha256sumzd2binzb0zz__cryptozd2utilzd2(obj_t BgL_envz00_1020, obj_t BgL_inz00_1021)
{
{ /* Llib/util.scm 249 */
return 
BGl_sha256sumzd2binzd2zz__cryptozd2utilzd2(BgL_inz00_1021);} 

}



/* sha512sum-bin */
BGL_EXPORTED_DEF obj_t BGl_sha512sumzd2binzd2zz__cryptozd2utilzd2(obj_t BgL_inz00_54)
{
{ /* Llib/util.scm 252 */
return 
BGl_stringzd2hexzd2internz12z12zz__r4_strings_6_7z00(
BGl_sha512sumz00zz__sha2z00(BgL_inz00_54));} 

}



/* &sha512sum-bin */
obj_t BGl_z62sha512sumzd2binzb0zz__cryptozd2utilzd2(obj_t BgL_envz00_1022, obj_t BgL_inz00_1023)
{
{ /* Llib/util.scm 252 */
return 
BGl_sha512sumzd2binzd2zz__cryptozd2utilzd2(BgL_inz00_1023);} 

}



/* md5sum-bin */
BGL_EXPORTED_DEF obj_t BGl_md5sumzd2binzd2zz__cryptozd2utilzd2(obj_t BgL_inz00_55)
{
{ /* Llib/util.scm 255 */
return 
BGl_stringzd2hexzd2internz12z12zz__r4_strings_6_7z00(
BGl_md5sumz00zz__md5z00(BgL_inz00_55));} 

}



/* &md5sum-bin */
obj_t BGl_z62md5sumzd2binzb0zz__cryptozd2utilzd2(obj_t BgL_envz00_1024, obj_t BgL_inz00_1025)
{
{ /* Llib/util.scm 255 */
return 
BGl_md5sumzd2binzd2zz__cryptozd2utilzd2(BgL_inz00_1025);} 

}



/* _make-random-prime */
obj_t BGl__makezd2randomzd2primez00zz__cryptozd2utilzd2(obj_t BgL_env1059z00_60, obj_t BgL_opt1058z00_59)
{
{ /* Llib/util.scm 261 */
{ 
 obj_t BgL_k1z00_362; long BgL_iz00_363;
{ /* Llib/util.scm 261 */
 obj_t BgL_fromz00_365; obj_t BgL_toz00_366;
BgL_fromz00_365 = 
VECTOR_REF(BgL_opt1058z00_59,((long)0)); 
BgL_toz00_366 = 
VECTOR_REF(BgL_opt1058z00_59,((long)1)); 
{ /* Llib/util.scm 261 */
 obj_t BgL_showzd2tracezd2_367;
BgL_showzd2tracezd2_367 = BFALSE; 
{ /* Llib/util.scm 261 */

{ 
 long BgL_iz00_368;
BgL_iz00_368 = ((long)2); 
BgL_check1062z00_369:
if(
(BgL_iz00_368==
VECTOR_LENGTH(BgL_opt1058z00_59)))
{ /* Llib/util.scm 261 */BNIL; }  else 
{ /* Llib/util.scm 261 */
 bool_t BgL_test1898z00_1896;
{ /* Llib/util.scm 261 */
 obj_t BgL_arg1351z00_375;
BgL_arg1351z00_375 = 
VECTOR_REF(BgL_opt1058z00_59,BgL_iz00_368); 
BgL_test1898z00_1896 = 
CBOOL(
BGl_memqz00zz__r4_pairs_and_lists_6_3z00(BgL_arg1351z00_375, 
CNST_TABLE_REF(((long)3)))); } 
if(BgL_test1898z00_1896)
{ 
 long BgL_iz00_1901;
BgL_iz00_1901 = 
(BgL_iz00_368+((long)2)); 
BgL_iz00_368 = BgL_iz00_1901; 
goto BgL_check1062z00_369;}  else 
{ /* Llib/util.scm 261 */
 obj_t BgL_arg1349z00_374;
BgL_arg1349z00_374 = 
VECTOR_REF(BgL_opt1058z00_59,BgL_iz00_368); 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string1730z00zz__cryptozd2utilzd2, BgL_arg1349z00_374); } } } 
{ /* Llib/util.scm 261 */
 obj_t BgL_index1064z00_376;
BgL_k1z00_362 = 
CNST_TABLE_REF(((long)4)); 
BgL_iz00_363 = ((long)2); 
BgL_search1061z00_364:
if(
(BgL_iz00_363==
VECTOR_LENGTH(BgL_opt1058z00_59)))
{ /* Llib/util.scm 261 */
BgL_index1064z00_376 = 
BINT(((long)-1)); }  else 
{ /* Llib/util.scm 261 */
if(
(BgL_iz00_363==
(
VECTOR_LENGTH(BgL_opt1058z00_59)-((long)1))))
{ /* Llib/util.scm 261 */
BgL_index1064z00_376 = 
BGl_errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string1745z00zz__cryptozd2utilzd2, 
BINT(
VECTOR_LENGTH(BgL_opt1058z00_59))); }  else 
{ /* Llib/util.scm 261 */
 obj_t BgL_vz00_385;
BgL_vz00_385 = 
VECTOR_REF(BgL_opt1058z00_59,BgL_iz00_363); 
if(
(BgL_vz00_385==BgL_k1z00_362))
{ /* Llib/util.scm 261 */
BgL_index1064z00_376 = 
BINT(
(BgL_iz00_363+((long)1))); }  else 
{ 
 long BgL_iz00_1923;
BgL_iz00_1923 = 
(BgL_iz00_363+((long)2)); 
BgL_iz00_363 = BgL_iz00_1923; 
goto BgL_search1061z00_364;} } } 
{ /* Llib/util.scm 261 */
 bool_t BgL_test1902z00_1926;
{ /* Llib/util.scm 261 */
 long BgL_n1z00_920;
{ /* Llib/util.scm 261 */
 obj_t BgL_tmpz00_1927;
if(
INTEGERP(BgL_index1064z00_376))
{ /* Llib/util.scm 261 */
BgL_tmpz00_1927 = BgL_index1064z00_376
; }  else 
{ 
 obj_t BgL_auxz00_1930;
BgL_auxz00_1930 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)7932)), BGl_string1746z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_index1064z00_376); 
FAILURE(BgL_auxz00_1930,BFALSE,BFALSE);} 
BgL_n1z00_920 = 
(long)CINT(BgL_tmpz00_1927); } 
BgL_test1902z00_1926 = 
(BgL_n1z00_920>=((long)0)); } 
if(BgL_test1902z00_1926)
{ 
 long BgL_auxz00_1936;
{ /* Llib/util.scm 261 */
 obj_t BgL_tmpz00_1937;
if(
INTEGERP(BgL_index1064z00_376))
{ /* Llib/util.scm 261 */
BgL_tmpz00_1937 = BgL_index1064z00_376
; }  else 
{ 
 obj_t BgL_auxz00_1940;
BgL_auxz00_1940 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)7932)), BGl_string1746z00zz__cryptozd2utilzd2, BGl_string1717z00zz__cryptozd2utilzd2, BgL_index1064z00_376); 
FAILURE(BgL_auxz00_1940,BFALSE,BFALSE);} 
BgL_auxz00_1936 = 
(long)CINT(BgL_tmpz00_1937); } 
BgL_showzd2tracezd2_367 = 
VECTOR_REF(BgL_opt1058z00_59,BgL_auxz00_1936); }  else 
{ /* Llib/util.scm 261 */BFALSE; } } } 
{ /* Llib/util.scm 261 */
 obj_t BgL_arg1354z00_378; obj_t BgL_arg1355z00_379;
BgL_arg1354z00_378 = 
VECTOR_REF(BgL_opt1058z00_59,((long)0)); 
BgL_arg1355z00_379 = 
VECTOR_REF(BgL_opt1058z00_59,((long)1)); 
{ /* Llib/util.scm 261 */
 obj_t BgL_showzd2tracezd2_380;
BgL_showzd2tracezd2_380 = BgL_showzd2tracezd2_367; 
{ /* Llib/util.scm 261 */
 obj_t BgL_auxz00_1955; obj_t BgL_auxz00_1948;
if(
BIGNUMP(BgL_arg1355z00_379))
{ /* Llib/util.scm 261 */
BgL_auxz00_1955 = BgL_arg1355z00_379
; }  else 
{ 
 obj_t BgL_auxz00_1958;
BgL_auxz00_1958 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)7932)), BGl_string1746z00zz__cryptozd2utilzd2, BGl_string1715z00zz__cryptozd2utilzd2, BgL_arg1355z00_379); 
FAILURE(BgL_auxz00_1958,BFALSE,BFALSE);} 
if(
BIGNUMP(BgL_arg1354z00_378))
{ /* Llib/util.scm 261 */
BgL_auxz00_1948 = BgL_arg1354z00_378
; }  else 
{ 
 obj_t BgL_auxz00_1951;
BgL_auxz00_1951 = 
BGl_typezd2errorzd2zz__errorz00(BGl_string1713z00zz__cryptozd2utilzd2, 
BINT(((long)7932)), BGl_string1746z00zz__cryptozd2utilzd2, BGl_string1715z00zz__cryptozd2utilzd2, BgL_arg1354z00_378); 
FAILURE(BgL_auxz00_1951,BFALSE,BFALSE);} 
return 
BGl_makezd2randomzd2primez00zz__cryptozd2utilzd2(BgL_auxz00_1948, BgL_auxz00_1955, BgL_showzd2tracezd2_380);} } } } } } } } 

}



/* make-random-prime */
BGL_EXPORTED_DEF obj_t BGl_makezd2randomzd2primez00zz__cryptozd2utilzd2(obj_t BgL_startz00_56, obj_t BgL_endz00_57, obj_t BgL_showzd2tracezd2_58)
{
{ /* Llib/util.scm 261 */
{ 
 long BgL_nz00_421;
if(
CBOOL(BgL_showzd2tracezd2_58))
{ /* Llib/util.scm 273 */
{ /* Llib/util.scm 274 */
 obj_t BgL_arg1373z00_390;
{ /* Llib/util.scm 274 */
 obj_t BgL_tmpz00_1965;
BgL_tmpz00_1965 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1373z00_390 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1965); } 
bgl_display_string(BGl_string1747z00zz__cryptozd2utilzd2, BgL_arg1373z00_390); } 
{ /* Llib/util.scm 275 */
 obj_t BgL_arg1374z00_391;
{ /* Llib/util.scm 275 */
 obj_t BgL_tmpz00_1969;
BgL_tmpz00_1969 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1374z00_391 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1969); } 
bgl_flush_output_port(BgL_arg1374z00_391); } }  else 
{ /* Llib/util.scm 273 */BFALSE; } 
{ /* Llib/util.scm 277 */
 obj_t BgL_prodzd2smallzd2primesz00_392;
BgL_nz00_421 = ((long)300); 
{ /* Llib/util.scm 264 */
 long BgL_g1029z00_423;
BgL_g1029z00_423 = 
(BgL_nz00_421-((long)1)); 
{ 
 long BgL_nz00_425; obj_t BgL_pz00_426; long BgL_iz00_427;
BgL_nz00_425 = BgL_g1029z00_423; 
BgL_pz00_426 = 
CNST_TABLE_REF(((long)8)); 
BgL_iz00_427 = ((long)3); 
BgL_zc3z04anonymousza31564ze3z87_428:
if(
(BgL_nz00_425==((long)0)))
{ /* Llib/util.scm 266 */
BgL_prodzd2smallzd2primesz00_392 = BgL_pz00_426; }  else 
{ /* Llib/util.scm 268 */
 bool_t BgL_test1909z00_1976;
{ /* Llib/util.scm 268 */
 obj_t BgL_arg1615z00_440;
{ /* Llib/util.scm 268 */
 obj_t BgL_arg1616z00_441;
BgL_arg1616z00_441 = 
bgl_long_to_bignum(BgL_iz00_427); 
{ /* Llib/util.scm 268 */
 obj_t BgL_list1617z00_442;
{ /* Llib/util.scm 268 */
 obj_t BgL_arg1635z00_443;
BgL_arg1635z00_443 = 
MAKE_YOUNG_PAIR(BgL_pz00_426, BNIL); 
BgL_list1617z00_442 = 
MAKE_YOUNG_PAIR(BgL_arg1616z00_441, BgL_arg1635z00_443); } 
BgL_arg1615z00_440 = 
BGl_gcdbxz00zz__r4_numbers_6_5_fixnumz00(BgL_list1617z00_442); } } 
BgL_test1909z00_1976 = 
(
(long)(
bgl_bignum_cmp(
CNST_TABLE_REF(((long)6)), BgL_arg1615z00_440))==((long)0)); } 
if(BgL_test1909z00_1976)
{ 
 long BgL_iz00_1990; obj_t BgL_pz00_1987; long BgL_nz00_1985;
BgL_nz00_1985 = 
(BgL_nz00_425-((long)1)); 
BgL_pz00_1987 = 
bgl_bignum_mul(BgL_pz00_426, 
bgl_long_to_bignum(BgL_iz00_427)); 
BgL_iz00_1990 = 
(BgL_iz00_427+((long)2)); 
BgL_iz00_427 = BgL_iz00_1990; 
BgL_pz00_426 = BgL_pz00_1987; 
BgL_nz00_425 = BgL_nz00_1985; 
goto BgL_zc3z04anonymousza31564ze3z87_428;}  else 
{ 
 long BgL_iz00_1992;
BgL_iz00_1992 = 
(BgL_iz00_427+((long)2)); 
BgL_iz00_427 = BgL_iz00_1992; 
goto BgL_zc3z04anonymousza31564ze3z87_428;} } } } 
{ 
 obj_t BgL_nz00_412;
{ 
 long BgL_iz00_395;
BgL_iz00_395 = ((long)1); 
BgL_zc3z04anonymousza31375ze3z87_396:
if(
CBOOL(BgL_showzd2tracezd2_58))
{ /* Llib/util.scm 284 */
{ /* Llib/util.scm 285 */
 obj_t BgL_arg1376z00_397;
{ /* Llib/util.scm 285 */
 obj_t BgL_tmpz00_1997;
BgL_tmpz00_1997 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1376z00_397 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_1997); } 
bgl_display_string(BGl_string1748z00zz__cryptozd2utilzd2, BgL_arg1376z00_397); } 
{ /* Llib/util.scm 286 */
 obj_t BgL_arg1377z00_398;
{ /* Llib/util.scm 286 */
 obj_t BgL_tmpz00_2001;
BgL_tmpz00_2001 = 
BGL_CURRENT_DYNAMIC_ENV(); 
BgL_arg1377z00_398 = 
BGL_ENV_CURRENT_OUTPUT_PORT(BgL_tmpz00_2001); } 
bgl_flush_output_port(BgL_arg1377z00_398); } }  else 
{ /* Llib/util.scm 284 */BFALSE; } 
{ /* Llib/util.scm 287 */
 obj_t BgL_xz00_399;
{ /* Llib/util.scm 287 */
 obj_t BgL_arg1449z00_409;
{ /* Llib/util.scm 287 */
 obj_t BgL_arg1534z00_410;
BgL_arg1534z00_410 = 
bgl_bignum_sub(BgL_endz00_57, BgL_startz00_56); 
if(
(
bgl_bignum_to_long(BgL_arg1534z00_410)==((long)0)))
{ /* Llib/util.scm 287 */
BgL_arg1449z00_409 = 
CNST_TABLE_REF(((long)1)); }  else 
{ /* Llib/util.scm 287 */
BgL_arg1449z00_409 = 
bgl_rand_bignum(BgL_arg1534z00_410); } } 
BgL_xz00_399 = 
bgl_bignum_add(BgL_startz00_56, BgL_arg1449z00_409); } 
{ /* Llib/util.scm 287 */
 obj_t BgL_nz00_400;
if(
bgl_bignum_odd(BgL_xz00_399))
{ /* Llib/util.scm 288 */
BgL_nz00_400 = BgL_xz00_399; }  else 
{ /* Llib/util.scm 288 */
BgL_nz00_400 = 
bgl_bignum_add(BgL_xz00_399, 
CNST_TABLE_REF(((long)6))); } 
{ /* Llib/util.scm 288 */

{ /* Llib/util.scm 289 */
 bool_t BgL_test1913z00_2016;
if(
(
(long)(
bgl_bignum_cmp(BgL_nz00_400, BgL_endz00_57))>=((long)0)))
{ /* Llib/util.scm 289 */
BgL_test1913z00_2016 = ((bool_t)1)
; }  else 
{ /* Llib/util.scm 289 */
 bool_t BgL_test1915z00_2021;
BgL_nz00_412 = BgL_nz00_400; 
{ /* Llib/util.scm 280 */
 bool_t BgL_test1916z00_2022;
{ /* Llib/util.scm 280 */
 obj_t BgL_arg1554z00_417;
{ /* Llib/util.scm 280 */
 obj_t BgL_list1555z00_418;
{ /* Llib/util.scm 280 */
 obj_t BgL_arg1562z00_419;
BgL_arg1562z00_419 = 
MAKE_YOUNG_PAIR(BgL_prodzd2smallzd2primesz00_392, BNIL); 
BgL_list1555z00_418 = 
MAKE_YOUNG_PAIR(BgL_nz00_412, BgL_arg1562z00_419); } 
BgL_arg1554z00_417 = 
BGl_gcdbxz00zz__r4_numbers_6_5_fixnumz00(BgL_list1555z00_418); } 
BgL_test1916z00_2022 = 
(
(long)(
bgl_bignum_cmp(
CNST_TABLE_REF(((long)6)), BgL_arg1554z00_417))==((long)0)); } 
if(BgL_test1916z00_2022)
{ /* Llib/util.scm 281 */
 obj_t BgL_n2z00_946;
{ /* Llib/util.scm 281 */
 obj_t BgL_xz00_1118; obj_t BgL_yz00_1119;
BgL_xz00_1118 = 
CNST_TABLE_REF(((long)8)); 
BgL_yz00_1119 = 
bgl_bignum_sub(BgL_nz00_412, 
CNST_TABLE_REF(((long)6))); 
BgL_n2z00_946 = 
BGl_exptzd2modze70z35zz__cryptozd2utilzd2(BgL_xz00_1118, BgL_yz00_1119, BgL_nz00_412); } 
BgL_test1915z00_2021 = 
(
(long)(
bgl_bignum_cmp(
CNST_TABLE_REF(((long)6)), BgL_n2z00_946))==((long)0)); }  else 
{ /* Llib/util.scm 280 */
BgL_test1915z00_2021 = ((bool_t)0)
; } } 
if(BgL_test1915z00_2021)
{ /* Llib/util.scm 289 */
BgL_test1913z00_2016 = ((bool_t)0)
; }  else 
{ /* Llib/util.scm 289 */
BgL_test1913z00_2016 = ((bool_t)1)
; } } 
if(BgL_test1913z00_2016)
{ 
 long BgL_iz00_2038;
BgL_iz00_2038 = 
(BgL_iz00_395+((long)1)); 
BgL_iz00_395 = BgL_iz00_2038; 
goto BgL_zc3z04anonymousza31375ze3z87_396;}  else 
{ /* Llib/util.scm 289 */
return BgL_nz00_400;} } } } } } } } } } 

}



/* object-init */
obj_t BGl_objectzd2initzd2zz__cryptozd2utilzd2()
{
{ /* Llib/util.scm 1 */
return BUNSPEC;} 

}



/* generic-init */
obj_t BGl_genericzd2initzd2zz__cryptozd2utilzd2()
{
{ /* Llib/util.scm 1 */
return BUNSPEC;} 

}



/* method-init */
obj_t BGl_methodzd2initzd2zz__cryptozd2utilzd2()
{
{ /* Llib/util.scm 1 */
return BUNSPEC;} 

}

#ifdef __cplusplus
}
#endif
